#ifndef LIB_DBG_DEBUG_MQLAPI_MQL5_TRACER_MQH_INCLUDED
#define LIB_DBG_DEBUG_MQLAPI_MQL5_TRACER_MQH_INCLUDED
#property version "5.50"
/**********************************************************************************
 * Copyright (C) 2020 Dominik Egert <info@freie-netze.de>
 *
 * This file is the MQL-API MQL5 rewrite functions include file.
 *
 * Lisence applied: GPLv2
 *                  https://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 *
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 4120
 *  State: public
 *
 *  File information
 *  ================
 *
*/




//*********************************************************************************************************************************************************/
//  BEGIN MQLAPI tracer
//


/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MQL5 API function call meta object
//

#ifndef __MQL4__
    namespace dbg_lib
    {

#endif

    template <typename EXT_OBJ>
    class LIB_DBG_NAMESPACE_DEF(dbg_lib, mqlapi_call_tracer_object_mql5) : public LIB_DBG_NAMESPACE_DEF(dbg_lib, mqlapi_call_tracer_object_mql45)<EXT_OBJ>
    {
        public:
        // Debug location recorder

            LIB_DBG_NAMESPACE_DEF(dbg_lib, mqlapi_call_tracer_object_mql5)<EXT_OBJ>* trace_call_details(const int _line_in, const char _func_id, const string _file_in, const string _function_in, const string _mqlapi_func, const string _api_name = NULL)
            {
                // Base class function
                LIB_DBG_NAMESPACE_DEF(dbg_lib, mqlapi_call_tracer_object)<EXT_OBJ>::trace_call_details(_line_in, _func_id, _file_in, _function_in, _mqlapi_func, _api_name);

                // Return
                return(GetPointer(this));
            };


        // MQL-API rewrite functions with return values

            template <typename T> bool dbg_mqlapi_trace_func_ArraySort(T& array[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySort(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArraySort(T& array[][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySort(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArraySort(T& array[][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySort(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArraySort(T& array[][][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySort(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayInsert(T& dst_array[], const T& src_array[], uint dst_start, uint src_start = 0, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, dst_array, src_array, dst_start, src_start, count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayInsert(dst_array, src_array, dst_start, src_start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dst_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayInsert(T& dst_array[][], const T& src_array[][], uint dst_start, uint src_start = 0, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, dst_array, src_array, dst_start, src_start, count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayInsert(dst_array, src_array, dst_start, src_start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dst_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayInsert(T& dst_array[][][], const T& src_array[][][], uint dst_start, uint src_start = 0, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, dst_array, src_array, dst_start, src_start, count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayInsert(dst_array, src_array, dst_start, src_start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dst_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayInsert(T& dst_array[][][][], const T& src_array[][][][], uint dst_start, uint src_start = 0, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, dst_array, src_array, dst_start, src_start, count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayInsert(dst_array, src_array, dst_start, src_start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dst_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayRemove(T& array[], uint start, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayRemove(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayRemove(T& array[][], uint start, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayRemove(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayRemove(T& array[][][], uint start, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayRemove(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayRemove(T& array[][][][], uint start, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayRemove(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayReverse(T& array[], uint start = 0, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, start, count, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayReverse(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayReverse(T& array[][], uint start = 0, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, start, count, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayReverse(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayReverse(T& array[][][], uint start = 0, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, start, count, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayReverse(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayReverse(T& array[][][][], uint start = 0, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, start, count, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayReverse(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArraySwap(T& array1[], T& array2[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array1, array2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySwap(array1, array2);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, array1, array2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArraySwap(T& array1[][], T& array2[][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array1, array2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySwap(array1, array2);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, array1, array2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArraySwap(T& array1[][][], T& array2[][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array1, array2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySwap(array1, array2);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, array1, array2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArraySwap(T& array1[][][][], T& array2[][][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array1, array2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySwap(array1, array2);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, array1, array2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_Bars(string symbol_name, ENUM_TIMEFRAMES timeframe)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, symbol_name, timeframe, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::Bars(symbol_name, timeframe);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_Bars(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, datetime stop_time)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, stop_time, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::Bars(symbol_name, timeframe, start_time, stop_time);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_BarsCalculated(int indicator_handle)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, indicator_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::BarsCalculated(indicator_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CalendarCountryById(const long country_id, MqlCalendarCountry& country)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, country_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CalendarCountryById(country_id, country);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, country, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CalendarEventById(ulong event_id, MqlCalendarEvent& event)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, event_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CalendarEventById(event_id, event);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, event, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CalendarValueById(ulong value_id, MqlCalendarValue& value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CalendarValueById(value_id, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CalendarCountries(MqlCalendarCountry& countries[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CalendarCountries(countries);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, countries, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CalendarEventByCountry(string country_code, MqlCalendarEvent& events[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, country_code, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CalendarEventByCountry(country_code, events);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, events, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CalendarEventByCurrency(const string currency, MqlCalendarEvent& events[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, currency, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CalendarEventByCurrency(currency, events);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, events, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CalendarValueHistoryByEvent(ulong event_id, MqlCalendarValue& values[], datetime datetime_from, datetime datetime_to = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, event_id, datetime_from, datetime_to, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CalendarValueHistoryByEvent(event_id, values, datetime_from, datetime_to);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, values, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CalendarValueHistory(MqlCalendarValue& values[], datetime datetime_from, datetime datetime_to = 0, const string country_code = NULL, const string currency = NULL)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, datetime_from, datetime_to, country_code, currency, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CalendarValueHistory(values, datetime_from, datetime_to, country_code, currency);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, values, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CalendarValueLastByEvent(ulong event_id, ulong& change_id, MqlCalendarValue& values[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, event_id, change_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CalendarValueLastByEvent(event_id, change_id, values);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, values, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CalendarValueLast(ulong& change_id, MqlCalendarValue& values[], const string country_code = NULL, const string currency = NULL)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, change_id, country_code, currency, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CalendarValueLast(change_id, values, country_code, currency);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, values, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T>
            bool dbg_mqlapi_trace_func_CharArrayToStruct(T& struct_object, const uchar& char_array[], uint start_pos = 0)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, char_array, start_pos, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CharArrayToStruct(struct_object, char_array, start_pos);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, struct_object, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartIndicatorAdd(long chart_id, int sub_window, int indicator_handle)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, sub_window, indicator_handle, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartIndicatorAdd(chart_id, sub_window, indicator_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ChartIndicatorGet(long chart_id, int sub_window, const string indicator_shortname)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, sub_window, indicator_shortname, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartIndicatorGet(chart_id, sub_window, indicator_shortname);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CLBufferCreate(int context, uint size, uint flags)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;                
                const bool _CL_MEM_READ_WRITE       = ((flags & CL_MEM_READ_WRITE) != NULL);
                const bool _CL_MEM_WRITE_ONLY       = ((flags & CL_MEM_WRITE_ONLY) != NULL);
                const bool _CL_MEM_READ_ONLY        = ((flags & CL_MEM_READ_ONLY) != NULL);
                const bool _CL_MEM_ALLOC_HOST_PTR   = ((flags & CL_MEM_ALLOC_HOST_PTR) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, context, size, flags, _CL_MEM_READ_WRITE, _CL_MEM_WRITE_ONLY, _CL_MEM_READ_ONLY, _CL_MEM_ALLOC_HOST_PTR);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLBufferCreate(context, size, flags);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> uint dbg_mqlapi_trace_func_CLBufferRead(int buffer, const T& data[], uint buffer_offset = 0, uint data_offset = 0, uint data_count = WHOLE_ARRAY)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, buffer, data, buffer_offset, data_offset, data_count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLBufferRead(buffer, data, buffer_offset, data_offset, data_count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            uint dbg_mqlapi_trace_func_CLBufferRead(int buffer, uint buffer_offset, matrix& mat, ulong rows = -1, ulong cols = -1)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, buffer, buffer_offset, mat, rows, cols, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLBufferRead(buffer, buffer_offset, mat, rows, cols);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            uint dbg_mqlapi_trace_func_CLBufferRead(int buffer, uint buffer_offset, vector& vec, ulong size = -1)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, buffer, buffer_offset, vec, size, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLBufferRead(buffer, buffer_offset, vec, size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> uint dbg_mqlapi_trace_func_CLBufferWrite(int buffer, const T& data[], uint buffer_offset = 0, uint data_offset = 0, uint data_count = WHOLE_ARRAY)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, buffer, data, buffer_offset, data_offset, data_count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLBufferWrite(buffer, data, buffer_offset, data_offset, data_count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> uint dbg_mqlapi_trace_func_CLBufferWrite(int buffer, uint buffer_offset, const T &mat_vec)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, buffer, buffer_offset, mat_vec, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLBufferWrite(buffer, buffer_offset, mat_vec);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CLContextCreate(int device)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, device, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLContextCreate(device);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CLExecute(int kernel)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, kernel, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLExecute(kernel);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CLExecute(int kernel, uint work_dim, const uint& global_work_offset[], const uint& global_work_size[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, kernel, work_dim, global_work_offset, global_work_size, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLExecute(kernel, work_dim, global_work_offset, global_work_size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CLExecute(int kernel, uint work_dim, const uint& global_work_offset[], const uint& global_work_size[], const uint& local_work_size[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, kernel, work_dim, global_work_offset, global_work_size, local_work_size, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLExecute(kernel, work_dim, global_work_offset, global_work_size, local_work_size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CLGetDeviceInfo(int handle, int property_id, uchar& data[], uint& size)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, handle, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLGetDeviceInfo(handle, property_id, data, size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, data, size, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_CLGetInfoInteger(int handle, ENUM_OPENCL_PROPERTY_INTEGER prop)
            {
                switch(prop)
                {
                    case CL_DEVICE_TYPE:    return(dbg_mqlapi_trace_func_CLGetInfoInteger_ENUM_CL_DEVICE_TYPE(handle, prop));
                }
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, handle, prop, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLGetInfoInteger(handle, prop);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_CLGetInfoInteger_ENUM_CL_DEVICE_TYPE(int handle, ENUM_OPENCL_PROPERTY_INTEGER prop)
            {
                ENUM_CL_DEVICE_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, handle, prop, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_CL_DEVICE_TYPE)::CLGetInfoInteger(handle, prop);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_CLGetInfoString(int handle, ENUM_OPENCL_PROPERTY_STRING prop, string& value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, handle, prop, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLGetInfoString(handle, prop, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ENUM_OPENCL_HANDLE_TYPE dbg_mqlapi_trace_func_CLHandleType(int handle)
            {
                ENUM_OPENCL_HANDLE_TYPE         retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLHandleType(handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CLKernelCreate(int program, const string kernel_name)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, program, kernel_name, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLKernelCreate(program, kernel_name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CLProgramCreate(int context, const string source)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, context, source, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLProgramCreate(context, source);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CLProgramCreate(int context, const string source, string &build_log)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, context, source, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLProgramCreate(context, source, build_log);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, build_log, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_CLSetKernelArg(int kernel, uint arg_index, T arg_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, kernel, arg_index, arg_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLSetKernelArg(kernel, arg_index, arg_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CLSetKernelArgMem(int kernel, uint arg_index, int cl_mem_handle)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, kernel, arg_index, cl_mem_handle, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLSetKernelArgMem(kernel, arg_index, cl_mem_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CLSetKernelArgMemLocal(int kernel, uint arg_index, ulong local_mem_size)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, kernel, arg_index, local_mem_size, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CLSetKernelArgMemLocal(kernel, arg_index, local_mem_size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyBuffer(int indicator_handle, int buffer_num, int start_pos, int count, double& buffer[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, indicator_handle, buffer_num, start_pos, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyBuffer(indicator_handle, buffer_num, start_pos, count, buffer);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, buffer, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyBuffer(int indicator_handle, int buffer_num, datetime start_time, int count, double& buffer[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, indicator_handle, buffer_num, start_time, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyBuffer(indicator_handle, buffer_num, start_time, count, buffer);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, buffer, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyBuffer(int indicator_handle, int buffer_num, datetime start_time, datetime stop_time, double& buffer[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, indicator_handle, buffer_num, start_time, stop_time, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyBuffer(indicator_handle, buffer_num, start_time, stop_time, buffer);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, buffer, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyTicks(string symbol_name, MqlTick& ticks_array[], uint flags = COPY_TICKS_ALL, ulong from = 0, uint count = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool COPY_TICKS_INFO          = ((flags & COPY_TICKS_INFO) != NULL);
                const bool COPY_TICKS_TRADE         = ((flags & COPY_TICKS_TRADE) != NULL);
                const bool COPY_TICKS_ALL           = ((flags & COPY_TICKS_ALL) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol_name, flags, from, count, COPY_TICKS_INFO, COPY_TICKS_TRADE, COPY_TICKS_ALL);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyTicks(symbol_name, ticks_array, flags, from, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, ticks_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyTicksRange(string symbol_name, MqlTick& ticks_array[], uint flags = COPY_TICKS_ALL, ulong from_msc = 0, ulong to_msc = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool COPY_TICKS_INFO          = ((flags & COPY_TICKS_INFO) != NULL);
                const bool COPY_TICKS_TRADE         = ((flags & COPY_TICKS_TRADE) != NULL);
                const bool COPY_TICKS_ALL           = ((flags & COPY_TICKS_ALL) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol_name, flags, from_msc, to_msc, COPY_TICKS_INFO, COPY_TICKS_TRADE, COPY_TICKS_ALL);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyTicksRange(symbol_name, ticks_array, flags, from_msc, to_msc);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, ticks_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CustomSymbolCreate(const string symbol_name, const string symbol_path = "", const string symbol_origin = NULL)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, symbol_path, symbol_origin, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolCreate(symbol_name, symbol_path, symbol_origin);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CustomSymbolDelete(const string symbol_name)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, symbol_name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolDelete(symbol_name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CustomSymbolSetInteger(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, long property_value)
            {
                switch(property_id)
                {
                    case SYMBOL_SECTOR:                     return(__CustomSymbolSetInteger_ENUM_SYMBOL_SECTOR(symbol_name, property_id, (ENUM_SYMBOL_SECTOR)property_value));
                    case SYMBOL_INDUSTRY:                   return(__CustomSymbolSetInteger_ENUM_SYMBOL_INDUSTRY(symbol_name, property_id, (ENUM_SYMBOL_INDUSTRY)property_value));
                    case SYMBOL_CHART_MODE:                 return(__CustomSymbolSetInteger_ENUM_SYMBOL_CHART_MODE(symbol_name, property_id, (ENUM_SYMBOL_CHART_MODE)property_value));
                    case SYMBOL_TRADE_CALC_MODE:            return(__CustomSymbolSetInteger_ENUM_SYMBOL_CALC_MODE(symbol_name, property_id, (ENUM_SYMBOL_CALC_MODE)property_value));
                    case SYMBOL_TRADE_MODE:                 return(__CustomSymbolSetInteger_ENUM_SYMBOL_TRADE_MODE(symbol_name, property_id, (ENUM_SYMBOL_TRADE_MODE)property_value));
                    case SYMBOL_TRADE_EXEMODE:              return(__CustomSymbolSetInteger_ENUM_SYMBOL_TRADE_EXECUTION(symbol_name, property_id, (ENUM_SYMBOL_TRADE_EXECUTION)property_value));
                    case SYMBOL_SWAP_MODE:                  return(__CustomSymbolSetInteger_ENUM_SYMBOL_SWAP_MODE(symbol_name, property_id, (ENUM_SYMBOL_SWAP_MODE)property_value));
                    case SYMBOL_SWAP_ROLLOVER3DAYS:         return(__CustomSymbolSetInteger_ENUM_DAY_OF_WEEK(symbol_name, property_id, (ENUM_DAY_OF_WEEK)property_value));
                    case SYMBOL_ORDER_GTC_MODE:             return(__CustomSymbolSetInteger_ENUM_SYMBOL_ORDER_GTC_MODE(symbol_name, property_id, (ENUM_SYMBOL_ORDER_GTC_MODE)property_value));
                    case SYMBOL_OPTION_MODE:                return(__CustomSymbolSetInteger_ENUM_SYMBOL_OPTION_MODE(symbol_name, property_id, (ENUM_SYMBOL_OPTION_MODE)property_value));
                    case SYMBOL_OPTION_RIGHT:               return(__CustomSymbolSetInteger_ENUM_SYMBOL_OPTION_RIGHT(symbol_name, property_id, (ENUM_SYMBOL_OPTION_RIGHT)property_value));
                    case SYMBOL_TIME:                       return(__CustomSymbolSetInteger_datetime(symbol_name, property_id, (datetime)property_value));
                    case SYMBOL_BACKGROUND_COLOR:           return(__CustomSymbolSetInteger_color(symbol_name, property_id, (color)property_value));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_ENUM_SYMBOL_SECTOR(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, ENUM_SYMBOL_SECTOR property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_ENUM_SYMBOL_INDUSTRY(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, ENUM_SYMBOL_INDUSTRY property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_ENUM_SYMBOL_CHART_MODE(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, ENUM_SYMBOL_CHART_MODE property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_ENUM_SYMBOL_CALC_MODE(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, ENUM_SYMBOL_CALC_MODE property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_ENUM_SYMBOL_TRADE_MODE(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, ENUM_SYMBOL_TRADE_MODE property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_ENUM_SYMBOL_TRADE_EXECUTION(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, ENUM_SYMBOL_TRADE_EXECUTION property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_ENUM_SYMBOL_SWAP_MODE(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, ENUM_SYMBOL_SWAP_MODE property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_ENUM_DAY_OF_WEEK(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, ENUM_DAY_OF_WEEK property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_ENUM_SYMBOL_ORDER_GTC_MODE(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, ENUM_SYMBOL_ORDER_GTC_MODE property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_ENUM_SYMBOL_OPTION_MODE(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, ENUM_SYMBOL_OPTION_MODE property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_ENUM_SYMBOL_OPTION_RIGHT(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, ENUM_SYMBOL_OPTION_RIGHT property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_datetime(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, datetime property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool __CustomSymbolSetInteger_color(const string symbol_name, ENUM_SYMBOL_INFO_INTEGER property_id, color property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetInteger(symbol_name, property_id, (long)property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CustomSymbolSetDouble(const string symbol_name, ENUM_SYMBOL_INFO_DOUBLE property_id, double property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetDouble(symbol_name, property_id, property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CustomSymbolSetString(const string symbol_name, ENUM_SYMBOL_INFO_STRING property_id, string property_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, property_id, property_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetString(symbol_name, property_id, property_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CustomSymbolSetMarginRate(const string symbol_name, ENUM_ORDER_TYPE order_type, double initial_margin_rate, double maintenance_margin_rate)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, order_type, initial_margin_rate, maintenance_margin_rate, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetMarginRate(symbol_name, order_type, initial_margin_rate, maintenance_margin_rate);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CustomSymbolSetSessionQuote(const string symbol_name, ENUM_DAY_OF_WEEK day_of_week, uint session_index, datetime from, datetime to)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol_name, day_of_week, session_index, from, to, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetSessionQuote(symbol_name, day_of_week, session_index, from, to);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CustomSymbolSetSessionTrade(const string symbol_name, ENUM_DAY_OF_WEEK day_of_week, uint session_index, datetime from, datetime to)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol_name, day_of_week, session_index, from, to, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomSymbolSetSessionTrade(symbol_name, day_of_week, session_index, from, to);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CustomRatesDelete(const string symbol, datetime from, datetime to)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, from, to, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomRatesDelete(symbol, from, to);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CustomRatesReplace(const string symbol, datetime from, datetime to, const MqlRates& rates[], uint count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, from, to, rates, count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomRatesReplace(symbol, from, to, rates, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CustomRatesUpdate(const string symbol, const MqlRates& rates[], uint count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, rates, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomRatesUpdate(symbol, rates, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CustomTicksAdd(const string symbol, const MqlTick& ticks[], uint count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, ticks, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomTicksAdd(symbol, ticks, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CustomTicksDelete(const string symbol, long from_msc, long to_msc)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, from_msc, to_msc, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomTicksDelete(symbol, from_msc, to_msc);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CustomTicksReplace(const string symbol, long from_msc, long to_msc, const MqlTick& ticks[], uint count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, from_msc, to_msc, ticks, count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomTicksReplace(symbol, from_msc, to_msc, ticks, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CustomBookAdd(const string symbol, const MqlBookInfo& books[], uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, books, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CustomBookAdd(symbol, books, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_DatabaseOpen(string filename, uint flags)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool DATABASE_OPEN_READONLY   = ((flags & ENUM_DATABASE_OPEN_FLAGS::DATABASE_OPEN_READONLY) != NULL);
                const bool DATABASE_OPEN_READWRITE  = ((flags & ENUM_DATABASE_OPEN_FLAGS::DATABASE_OPEN_READWRITE) != NULL);
                const bool DATABASE_OPEN_CREATE     = ((flags & ENUM_DATABASE_OPEN_FLAGS::DATABASE_OPEN_CREATE) != NULL);
                const bool DATABASE_OPEN_MEMORY     = ((flags & ENUM_DATABASE_OPEN_FLAGS::DATABASE_OPEN_MEMORY) != NULL);
                const bool DATABASE_OPEN_COMMON     = ((flags & ENUM_DATABASE_OPEN_FLAGS::DATABASE_OPEN_COMMON) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, filename, flags, DATABASE_OPEN_READONLY, DATABASE_OPEN_READWRITE, DATABASE_OPEN_CREATE, DATABASE_OPEN_MEMORY, DATABASE_OPEN_COMMON);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseOpen(filename, flags);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_DatabaseImport(int database, const string table, const string filename, uint flags, const string separator, ulong skip_rows, const string skip_comments)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool DATABASE_IMPORT_HEADER           = ((flags & ENUM_DATABASE_IMPORT_FLAGS::DATABASE_IMPORT_HEADER) != NULL);
                const bool DATABASE_IMPORT_CRLF             = ((flags & ENUM_DATABASE_IMPORT_FLAGS::DATABASE_IMPORT_CRLF) != NULL);
                const bool DATABASE_IMPORT_APPEND           = ((flags & ENUM_DATABASE_IMPORT_FLAGS::DATABASE_IMPORT_APPEND) != NULL);
                const bool DATABASE_IMPORT_QUOTED_STRINGS   = ((flags & ENUM_DATABASE_IMPORT_FLAGS::DATABASE_IMPORT_QUOTED_STRINGS) != NULL);
                const bool DATABASE_IMPORT_COMMON_FOLDER    = ((flags & ENUM_DATABASE_IMPORT_FLAGS::DATABASE_IMPORT_COMMON_FOLDER) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, DATABASE_IMPORT_HEADER, DATABASE_IMPORT_CRLF, DATABASE_IMPORT_APPEND, DATABASE_IMPORT_QUOTED_STRINGS, DATABASE_IMPORT_COMMON_FOLDER, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, database, table, filename, flags, separator, skip_rows, skip_comments);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseImport(database, table, filename, flags, separator, skip_rows, skip_comments);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_DatabaseExport(int database, const string table_or_sql, const string filename, uint flags, const string separator)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool DATABASE_EXPORT_HEADER           = ((flags & ENUM_DATABASE_EXPORT_FLAGS::DATABASE_EXPORT_HEADER) != NULL);
                const bool DATABASE_EXPORT_INDEX            = ((flags & ENUM_DATABASE_EXPORT_FLAGS::DATABASE_EXPORT_INDEX) != NULL);
                const bool DATABASE_EXPORT_NO_BOM           = ((flags & ENUM_DATABASE_EXPORT_FLAGS::DATABASE_EXPORT_NO_BOM) != NULL);
                const bool DATABASE_EXPORT_CRLF             = ((flags & ENUM_DATABASE_EXPORT_FLAGS::DATABASE_EXPORT_CRLF) != NULL);
                const bool DATABASE_EXPORT_APPEND           = ((flags & ENUM_DATABASE_EXPORT_FLAGS::DATABASE_EXPORT_APPEND) != NULL);
                const bool DATABASE_EXPORT_QUOTED_STRINGS   = ((flags & ENUM_DATABASE_EXPORT_FLAGS::DATABASE_EXPORT_QUOTED_STRINGS) != NULL);
                const bool DATABASE_EXPORT_COMMON_FOLDER    = ((flags & ENUM_DATABASE_EXPORT_FLAGS::DATABASE_EXPORT_COMMON_FOLDER) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, DATABASE_EXPORT_NO_BOM, DATABASE_EXPORT_CRLF, DATABASE_EXPORT_APPEND, DATABASE_EXPORT_QUOTED_STRINGS, DATABASE_EXPORT_COMMON_FOLDER, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, database, table_or_sql, filename, flags, separator, DATABASE_EXPORT_HEADER, DATABASE_EXPORT_INDEX);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseExport(database, table_or_sql, filename, flags, separator);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_DatabasePrint(int database, const string table_or_sql, uint flags)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool DATABASE_PRINT_NO_HEADER         = ((flags & DATABASE_PRINT_NO_HEADER) != NULL);
                const bool DATABASE_PRINT_NO_INDEX          = ((flags & DATABASE_PRINT_NO_INDEX) != NULL);
                const bool DATABASE_PRINT_NO_FRAME          = ((flags & DATABASE_PRINT_NO_FRAME) != NULL);
                const bool DATABASE_PRINT_STRINGS_RIGHT     = ((flags & DATABASE_PRINT_STRINGS_RIGHT) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, database, table_or_sql, flags, DATABASE_PRINT_NO_HEADER, DATABASE_PRINT_NO_INDEX, DATABASE_PRINT_NO_FRAME, DATABASE_PRINT_STRINGS_RIGHT);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabasePrint(database, table_or_sql, flags);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DatabaseTableExists(int database, string table)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, database, table, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseTableExists(database, table);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DatabaseExecute(int database, string sql)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, database, sql, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseExecute(database, sql);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_DatabaseReset(int request)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, request, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseReset(request);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_DatabaseBind(int request, int index, T value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, request, index, value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseBind(request, index, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_DatabaseBindArray(int request, int index, T& array[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, request, index, array, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseBindArray(request, index, array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DatabaseRead(int request)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, request, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseRead(request);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_DatabaseReadBind(int request, T& struct_object)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, request, struct_object, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseReadBind(request, struct_object);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DatabaseTransactionBegin(int database)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, database, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseTransactionBegin(database);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DatabaseTransactionCommit(int database)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, database, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseTransactionCommit(database);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DatabaseTransactionRollback(int database)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, database, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseTransactionRollback(database);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_DatabaseColumnsCount(int request)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, request, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseColumnsCount(request);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DatabaseColumnName(int request, int column, string& name)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, request, column, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseColumnName(request, column, name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ENUM_DATABASE_FIELD_TYPE dbg_mqlapi_trace_func_DatabaseColumnType(int request, int column)
            {
                ENUM_DATABASE_FIELD_TYPE        retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, request, column, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseColumnType(request, column);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_DatabaseColumnSize(int request, int column)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, request, column, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseColumnSize(request, column);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DatabaseColumnText(int request, int column, string& value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, request, column, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseColumnText(request, column, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DatabaseColumnInteger(int request, int column, int& value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, request, column, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseColumnInteger(request, column, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DatabaseColumnLong(int request, int column, long& value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, request, column, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseColumnLong(request, column, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DatabaseColumnDouble(int request, int column, double& value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, request, column, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseColumnDouble(request, column, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_DatabaseColumnBlob(int request, int column, T& data[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, request, column, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DatabaseColumnBlob(request, column, data);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, data, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_DXContextCreate(uint width, uint height)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, width, height, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXContextCreate(width, height);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXContextSetSize(int context, uint& width, uint& height)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, context, width, height, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXContextSetSize(context, width, height);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXContextGetSize(int context, uint& width, uint& height)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, context, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXContextGetSize(context, width, height);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, width, height, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXContextClearColors(int context, const DXVector& _color)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, context, _color, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXContextClearColors(context, _color);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXContextClearDepth(int context)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, context, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXContextClearDepth(context);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXContextGetColors(int context, uint& image[], int image_width = WHOLE_ARRAY, int image_height = WHOLE_ARRAY, int image_offset_x = 0, int image_offset_y = 0)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, context, image_width, image_height, image_offset_x, image_offset_y, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXContextGetColors(context, image, image_width, image_height, image_offset_x, image_offset_y);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, image, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXContextGetDepth(int context, float& image[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, context, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXContextGetDepth(context, image);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, image, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_DXBufferCreate(int context, ENUM_DX_BUFFER_TYPE buffer_type, const T& data[], uint start = 0, uint count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, context, buffer_type, data, start, count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXBufferCreate(context, buffer_type, data, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_DXTextureCreate(int context, ENUM_DX_FORMAT format, uint width, uint height, const T& data[], uint data_x, uint data_y, uint data_width, uint data_height)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, data_width, data_height, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, context, format, width, height, data, data_x, data_y);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXTextureCreate(context, format, width, height, data, data_x, data_y, data_width, data_height);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_DXInputCreate(int context, uint input_size)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, context, input_size, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXInputCreate(context, input_size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_DXInputSet(int _input, const T& data)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, _input, data, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXInputSet(_input, data);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_DXInputSet(int _input, const T& data[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, _input, data, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXInputSet(_input, data);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_DXInputSet(int _input, const T& data[][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, _input, data, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXInputSet(_input, data);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_DXInputSet(int _input, const T& data[][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, _input, data, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXInputSet(_input, data);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_DXInputSet(int _input, const T& data[][][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, _input, data, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXInputSet(_input, data);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_DXShaderCreate(int context, ENUM_DX_SHADER_TYPE shader_type, const string source, const string entry_point, string& compile_error)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, context, shader_type, source, entry_point, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXShaderCreate(context, shader_type, source, entry_point, compile_error);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, compile_error, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXShaderSetLayout(int shader, const DXVertexLayout& layout[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, shader, layout, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXShaderSetLayout(shader, layout);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXShaderInputsSet(int shader, const int& inputs[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, shader, inputs, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXShaderInputsSet(shader, inputs);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXShaderTexturesSet(int shader, const int& textures[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, shader, textures, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXShaderTexturesSet(shader, textures);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXDraw(int context, uint start = 0, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, context, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXDraw(context, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXDrawIndexed(int context, uint start = 0, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, context, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXDrawIndexed(context, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXPrimiveTopologySet(int context, ENUM_DX_PRIMITIVE_TOPOLOGY primitive_topology)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, context, primitive_topology, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXPrimiveTopologySet(context, primitive_topology);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXBufferSet(int context, int buffer, uint start = 0, uint count = WHOLE_ARRAY)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, context, buffer, start, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXBufferSet(context, buffer, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXShaderSet(int context, int shader)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, context, shader, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXShaderSet(context, shader);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ENUM_DX_HANDLE_TYPE             dbg_mqlapi_trace_func_DXHandleType(int handle)
            {
                ENUM_DX_HANDLE_TYPE             retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXHandleType(handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_DXRelease(int handle)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DXRelease(handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FrameAdd(const string name, long id, double value, const string filename)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, name, id, value, filename, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FrameAdd(name, id, value, filename);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_FrameAdd(const string name, long id, double value, const T& data[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, name, id, value, data, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FrameAdd(name, id, value, data);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FrameFilter(const string name, long id)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FrameFilter(name, id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FrameFirst()
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FrameFirst();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FrameInputs(ulong pass, string& parameters[], uint& parameters_count)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, pass, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FrameInputs(pass, parameters, parameters_count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, parameters, parameters_count, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FrameNext(ulong& pass, string& name, long& id, double& value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FrameNext(pass, name, id, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(4, pass, name, id, value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_FrameNext(ulong& pass, string& name, long& id, double& value, T& data[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FrameNext(pass, name, id, value, data);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(5, pass, name, id, value, data, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ulong dbg_mqlapi_trace_func_GetTickCount64()
            {
                ulong retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GetTickCount64();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_HistoryDealGetDouble(ulong ticket_number, ENUM_DEAL_PROPERTY_DOUBLE property_id)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealGetDouble(ticket_number, property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_HistoryDealGetDouble(ulong ticket_number, ENUM_DEAL_PROPERTY_DOUBLE property_id, double& double_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealGetDouble(ticket_number, property_id, double_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, double_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_HistoryDealGetInteger(ulong ticket_number, ENUM_DEAL_PROPERTY_INTEGER property_id)
            {
                switch(property_id)
                {
                    case DEAL_TIME:         return(dbg_mqlapi_trace_func_HistoryDealGetInteger_datetime(ticket_number, property_id));
                    case DEAL_TYPE:         return(dbg_mqlapi_trace_func_HistoryDealGetInteger_ENUM_DEAL_TYPE(ticket_number, property_id));
                    case DEAL_ENTRY:        return(dbg_mqlapi_trace_func_HistoryDealGetInteger_ENUM_DEAL_ENTRY(ticket_number, property_id));
                    case DEAL_REASON:       return(dbg_mqlapi_trace_func_HistoryDealGetInteger_ENUM_DEAL_REASON(ticket_number, property_id));
                }
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealGetInteger(ticket_number, property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_HistoryDealGetInteger(ulong ticket_number, ENUM_DEAL_PROPERTY_INTEGER property_id, long& long_var)
            {
                switch(property_id)
                {
                    case DEAL_TIME:         return(dbg_mqlapi_trace_func_HistoryDealGetInteger_datetime(ticket_number, property_id, long_var));
                    case DEAL_TYPE:         return(dbg_mqlapi_trace_func_HistoryDealGetInteger_ENUM_DEAL_TYPE(ticket_number, property_id, long_var));
                    case DEAL_ENTRY:        return(dbg_mqlapi_trace_func_HistoryDealGetInteger_ENUM_DEAL_ENTRY(ticket_number, property_id, long_var));
                    case DEAL_REASON:       return(dbg_mqlapi_trace_func_HistoryDealGetInteger_ENUM_DEAL_REASON(ticket_number, property_id, long_var));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealGetInteger(ticket_number, property_id, long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_HistoryDealGetInteger_datetime(ulong ticket_number, ENUM_DEAL_PROPERTY_INTEGER property_id)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (datetime)::HistoryDealGetInteger(ticket_number, property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_HistoryDealGetInteger_datetime(ulong ticket_number, ENUM_DEAL_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealGetInteger(ticket_number, property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const datetime long_var = (datetime)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_HistoryDealGetInteger_ENUM_DEAL_TYPE(ulong ticket_number, ENUM_DEAL_PROPERTY_INTEGER property_id)
            {
                ENUM_DEAL_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_DEAL_TYPE)::HistoryDealGetInteger(ticket_number, property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_HistoryDealGetInteger_ENUM_DEAL_TYPE(ulong ticket_number, ENUM_DEAL_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealGetInteger(ticket_number, property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_DEAL_TYPE long_var = (ENUM_DEAL_TYPE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_HistoryDealGetInteger_ENUM_DEAL_ENTRY(ulong ticket_number, ENUM_DEAL_PROPERTY_INTEGER property_id)
            {
                ENUM_DEAL_ENTRY retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_DEAL_ENTRY)::HistoryDealGetInteger(ticket_number, property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_HistoryDealGetInteger_ENUM_DEAL_ENTRY(ulong ticket_number, ENUM_DEAL_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealGetInteger(ticket_number, property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_DEAL_ENTRY long_var = (ENUM_DEAL_ENTRY)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_HistoryDealGetInteger_ENUM_DEAL_REASON(ulong ticket_number, ENUM_DEAL_PROPERTY_INTEGER property_id)
            {
                ENUM_DEAL_REASON retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_DEAL_REASON)::HistoryDealGetInteger(ticket_number, property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_HistoryDealGetInteger_ENUM_DEAL_REASON(ulong ticket_number, ENUM_DEAL_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealGetInteger(ticket_number, property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_DEAL_REASON long_var = (ENUM_DEAL_REASON)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_HistoryDealGetString(ulong ticket_number, ENUM_DEAL_PROPERTY_STRING property_id)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealGetString(ticket_number, property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_HistoryDealGetString(ulong ticket_number, ENUM_DEAL_PROPERTY_STRING property_id, string& string_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealGetString(ticket_number, property_id, string_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ulong dbg_mqlapi_trace_func_HistoryDealGetTicket(int index)
            {
                ulong retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, index, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealGetTicket(index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_HistoryDealSelect(ulong ticket)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, ticket, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealSelect(ticket);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_HistoryDealsTotal()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryDealsTotal();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_HistoryOrderGetDouble(ulong ticket_number, ENUM_ORDER_PROPERTY_DOUBLE property_id)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryOrderGetDouble(ticket_number, property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_HistoryOrderGetDouble(ulong ticket_number, ENUM_ORDER_PROPERTY_DOUBLE property_id, double& double_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryOrderGetDouble(ticket_number, property_id, double_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, double_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_HistoryOrderGetInteger(ulong ticket_number, ENUM_ORDER_PROPERTY_INTEGER property_id)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryOrderGetInteger(ticket_number, property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_HistoryOrderGetInteger(ulong ticket_number, ENUM_ORDER_PROPERTY_INTEGER property_id, long& long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryOrderGetInteger(ticket_number, property_id, long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_HistoryOrderGetString(ulong ticket_number, ENUM_ORDER_PROPERTY_STRING property_id)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryOrderGetString(ticket_number, property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_HistoryOrderGetString(ulong ticket_number, ENUM_ORDER_PROPERTY_STRING property_id, string& string_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, ticket_number, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryOrderGetString(ticket_number, property_id, string_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ulong dbg_mqlapi_trace_func_HistoryOrderGetTicket(int index)
            {
                ulong retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, index, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryOrderGetTicket(index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_HistoryOrderSelect(ulong ticket)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, ticket, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryOrderSelect(ticket);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_HistoryOrdersTotal()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistoryOrdersTotal();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_HistorySelect(datetime from_date, datetime to_date)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, from_date, to_date, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistorySelect(from_date, to_date);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_HistorySelectByPosition(long position_id)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, position_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::HistorySelectByPosition(position_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iAC(string symbol, ENUM_TIMEFRAMES period)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, symbol, period, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iAC(symbol, period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iAD(string symbol, ENUM_TIMEFRAMES period, ENUM_APPLIED_VOLUME applied_volume)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, applied_volume, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iAD(symbol, period, applied_volume);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iADX(string symbol, ENUM_TIMEFRAMES period, int adx_period)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, adx_period, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iADX(symbol, period, adx_period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iADXWilder(string symbol, ENUM_TIMEFRAMES period, int adx_period)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, adx_period, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iADXWilder(symbol, period, adx_period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iAlligator(string symbol, ENUM_TIMEFRAMES period, int jaw_period, int jaw_shift, int teeth_period, int teeth_shift, int lips_period, int lips_shift, ENUM_MA_METHOD ma_method, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, lips_shift, ma_method, applied_price, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, period, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iAlligator(symbol, period, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period, lips_shift, ma_method, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iAMA(string symbol, ENUM_TIMEFRAMES period, int ama_period, int fast_ma_period, int slow_ma_period, int ama_shift, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, period, ama_period, fast_ma_period, slow_ma_period, ama_shift, applied_price);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iAMA(symbol, period, ama_period, fast_ma_period, slow_ma_period, ama_shift, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iAO(string symbol, ENUM_TIMEFRAMES period)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, symbol, period, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iAO(symbol, period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iATR(string symbol, ENUM_TIMEFRAMES period, int ma_period)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, ma_period, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iATR(symbol, period, ma_period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iBands(string symbol, ENUM_TIMEFRAMES period, int bands_period, int bands_shift, double deviation, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, symbol, period, bands_period, bands_shift, deviation, applied_price, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iBands(symbol, period, bands_period, bands_shift, deviation, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iBars(const string symbol, ENUM_TIMEFRAMES timeframe)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, symbol, timeframe, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iBars(symbol, timeframe);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iBarShift(const string symbol, ENUM_TIMEFRAMES timeframe, datetime time, bool exact = false)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, timeframe, time, exact, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iBarShift(symbol, timeframe, time, exact);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iBearsPower(string symbol, ENUM_TIMEFRAMES period, int ma_period)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, ma_period, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iBearsPower(symbol, period, ma_period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iBullsPower(string symbol, ENUM_TIMEFRAMES period, int ma_period)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, ma_period, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iBullsPower(symbol, period, ma_period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iBWMFI(string symbol, ENUM_TIMEFRAMES period, ENUM_APPLIED_VOLUME applied_volume)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, applied_volume, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iBWMFI(symbol, period, applied_volume);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iCCI(string symbol, ENUM_TIMEFRAMES period, int ma_period, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, period, ma_period, applied_price, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iCCI(symbol, period, ma_period, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iChaikin(string symbol, ENUM_TIMEFRAMES period, int fast_ma_period, int slow_ma_period, ENUM_MA_METHOD ma_method, ENUM_APPLIED_VOLUME applied_volume)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, symbol, period, fast_ma_period, slow_ma_period, ma_method, applied_volume, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iChaikin(symbol, period, fast_ma_period, slow_ma_period, ma_method, applied_volume);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iClose(const string symbol, ENUM_TIMEFRAMES timeframe, int shift)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iClose(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iDEMA(string symbol, ENUM_TIMEFRAMES period, int ma_period, int ma_shift, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, period, ma_period, ma_shift, applied_price, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iDEMA(symbol, period, ma_period, ma_shift, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iDeMarker(string symbol, ENUM_TIMEFRAMES period, int ma_period)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, ma_period, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iDeMarker(symbol, period, ma_period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iEnvelopes(string symbol, ENUM_TIMEFRAMES period, int ma_period, int ma_shift, ENUM_MA_METHOD ma_method, ENUM_APPLIED_PRICE applied_price, double deviation)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, period, ma_period, ma_shift, ma_method, applied_price, deviation);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iEnvelopes(symbol, period, ma_period, ma_shift, ma_method, applied_price, deviation);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iForce(string symbol, ENUM_TIMEFRAMES period, int ma_period, ENUM_MA_METHOD ma_method, ENUM_APPLIED_VOLUME applied_volume)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, period, ma_period, ma_method, applied_volume, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iForce(symbol, period, ma_period, ma_method, applied_volume);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iFractals(string symbol, ENUM_TIMEFRAMES period)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, symbol, period, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iFractals(symbol, period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iFrAMA(string symbol, ENUM_TIMEFRAMES period, int ma_period, int ma_shift, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, period, ma_period, ma_shift, applied_price, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iFrAMA(symbol, period, ma_period, ma_shift, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iGator(string symbol, ENUM_TIMEFRAMES period, int jaw_period, int jaw_shift, int teeth_period, int teeth_shift, int lips_period, int lips_shift, ENUM_MA_METHOD ma_method, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, lips_shift, ma_method, applied_price, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, period, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iGator(symbol, period, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period, lips_shift, ma_method, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iHigh(const string symbol, ENUM_TIMEFRAMES timeframe, int shift)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iHigh(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iHighest(const string symbol, ENUM_TIMEFRAMES timeframe, ENUM_SERIESMODE type, int count = WHOLE_ARRAY, int start = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, timeframe, type, count, start, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iHighest(symbol, timeframe, type, count, start);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_IndicatorCreate(string symbol, ENUM_TIMEFRAMES period, ENUM_INDICATOR indicator_type, int parameters_cnt = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, period, indicator_type, parameters_cnt, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorCreate(symbol, period, indicator_type, parameters_cnt);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_IndicatorCreate(string symbol, ENUM_TIMEFRAMES period, ENUM_INDICATOR indicator_type, int parameters_cnt, const MqlParam& parameters_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, period, indicator_type, parameters_cnt, parameters_array, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorCreate(symbol, period, indicator_type, parameters_cnt, parameters_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_IndicatorParameters(int indicator_handle, ENUM_INDICATOR& indicator_type, MqlParam& parameters[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, indicator_handle, indicator_type, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorParameters(indicator_handle, indicator_type, parameters);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, parameters, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IndicatorRelease(int indicator_handle)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, indicator_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorRelease(indicator_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iIchimoku(string symbol, ENUM_TIMEFRAMES period, int tenkan_sen, int kijun_sen, int senkou_span_b)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, period, tenkan_sen, kijun_sen, senkou_span_b, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iIchimoku(symbol, period, tenkan_sen, kijun_sen, senkou_span_b);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iLow(const string symbol, ENUM_TIMEFRAMES timeframe, int shift)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iLow(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iLowest(const string symbol, ENUM_TIMEFRAMES timeframe, ENUM_SERIESMODE type, int count = WHOLE_ARRAY, int start = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, timeframe, type, count, start, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iLowest(symbol, timeframe, type, count, start);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iMA(string symbol, ENUM_TIMEFRAMES period, int ma_period, int ma_shift, ENUM_MA_METHOD ma_method, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, period, ma_period, ma_shift, ma_method, applied_price, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iMA(symbol, period, ma_period, ma_shift, ma_method, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iMACD(string symbol, ENUM_TIMEFRAMES period, int fast_ema_period, int slow_ema_period, int signal_period, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, symbol, period, fast_ema_period, slow_ema_period, signal_period, applied_price, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iMACD(symbol, period, fast_ema_period, slow_ema_period, signal_period, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iMFI(string symbol, ENUM_TIMEFRAMES period, int ma_period, ENUM_APPLIED_VOLUME applied_volume)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, period, ma_period, applied_volume, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iMFI(symbol, period, ma_period, applied_volume);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iMomentum(string symbol, ENUM_TIMEFRAMES period, int mom_period, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, period, mom_period, applied_price, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iMomentum(symbol, period, mom_period, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iOBV(string symbol, ENUM_TIMEFRAMES period, ENUM_APPLIED_VOLUME applied_volume)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, applied_volume, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iOBV(symbol, period, applied_volume);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_iOpen(const string symbol, ENUM_TIMEFRAMES timeframe, int shift)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iOpen(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iOsMA(string symbol, ENUM_TIMEFRAMES period, int fast_ema_period, int slow_ema_period, int signal_period, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, symbol, period, fast_ema_period, slow_ema_period, signal_period, applied_price, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iOsMA(symbol, period, fast_ema_period, slow_ema_period, signal_period, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_iRealVolume(const string symbol, ENUM_TIMEFRAMES timeframe, int shift)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iRealVolume(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iRSI(string symbol, ENUM_TIMEFRAMES period, int ma_period, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, period, ma_period, applied_price, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iRSI(symbol, period, ma_period, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iRVI(string symbol, ENUM_TIMEFRAMES period, int ma_period)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, ma_period, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iRVI(symbol, period, ma_period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iSAR(string symbol, ENUM_TIMEFRAMES period, double step, double maximum)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, period, step, maximum, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iSAR(symbol, period, step, maximum);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_iSpread(const string symbol, ENUM_TIMEFRAMES timeframe, int shift)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iSpread(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iStdDev(string symbol, ENUM_TIMEFRAMES period, int ma_period, int ma_shift, ENUM_MA_METHOD ma_method, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, symbol, period, ma_period, ma_shift, ma_method, applied_price, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iStdDev(symbol, period, ma_period, ma_shift, ma_method, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iStochastic(string symbol, ENUM_TIMEFRAMES period, int Kperiod, int Dperiod, int slowing, ENUM_MA_METHOD ma_method, ENUM_STO_PRICE price_field)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol, period, Kperiod, Dperiod, slowing, ma_method, price_field);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iStochastic(symbol, period, Kperiod, Dperiod, slowing, ma_method, price_field);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iTEMA(string symbol, ENUM_TIMEFRAMES period, int ma_period, int ma_shift, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, symbol, period, ma_period, ma_shift, applied_price, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iTEMA(symbol, period, ma_period, ma_shift, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_iTickVolume(const string symbol, ENUM_TIMEFRAMES timeframe, int shift)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, timeframe, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iTickVolume(symbol, timeframe, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_iTime(string symbol, ENUM_TIMEFRAMES period, int shift)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iTime(symbol, period, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iTriX(string symbol, ENUM_TIMEFRAMES period, int ma_period, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, period, ma_period, applied_price, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iTriX(symbol, period, ma_period, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iVIDyA(string symbol, ENUM_TIMEFRAMES period, int cmo_period, int ema_period, int ma_shift, ENUM_APPLIED_PRICE applied_price)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, symbol, period, cmo_period, ema_period, ma_shift, applied_price, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iVIDyA(symbol, period, cmo_period, ema_period, ma_shift, applied_price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_iVolume(string symbol, ENUM_TIMEFRAMES period, int shift)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iVolume(symbol, period, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iVolumes(string symbol, ENUM_TIMEFRAMES period, ENUM_APPLIED_VOLUME applied_volume)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, applied_volume, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iVolumes(symbol, period, applied_volume);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_iWPR(string symbol, ENUM_TIMEFRAMES period, int calc_period)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol, period, calc_period, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::iWPR(symbol, period, calc_period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_MarketBookAdd(string symbol)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, symbol, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MarketBookAdd(symbol);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_MarketBookGet(string symbol, MqlBookInfo& book[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, symbol, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MarketBookGet(symbol, book);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, book, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_MarketBookRelease(string symbol)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, symbol, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MarketBookRelease(symbol);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int         dbg_mqlapi_trace_func_MathAbs(char value)                                       { return(MathAbs_T<int, char>(value)); }
            int         dbg_mqlapi_trace_func_MathAbs(short value)                                      { return(MathAbs_T<int, short>(value)); }
            int         dbg_mqlapi_trace_func_MathAbs(int value)                                        { return(MathAbs_T<int, int>(value)); }
            long        dbg_mqlapi_trace_func_MathAbs(long value)                                       { return(MathAbs_T<long, long>(value)); }
            uchar       dbg_mqlapi_trace_func_MathAbs(uchar value)                                      { return(MathAbs_T<uchar, uchar>(value)); }
            ushort      dbg_mqlapi_trace_func_MathAbs(ushort value)                                     { return(MathAbs_T<ushort, ushort>(value)); }
            uint        dbg_mqlapi_trace_func_MathAbs(uint value)                                       { return(MathAbs_T<uint, uint>(value)); }
            ulong       dbg_mqlapi_trace_func_MathAbs(ulong value)                                      { return(MathAbs_T<ulong, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathAbs(float value)                                      { return(MathAbs_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathAbs(double value)                                     { return(MathAbs_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathAbs(const matrix& value)                              { return(MathAbs_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathAbs(const matrixf& value)                             { return(MathAbs_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathAbs(const vector& value)                              { return(MathAbs_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathAbs(const vectorf& value)                             { return(MathAbs_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathArccos(char value)                                    { return(MathArccos_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathArccos(short value)                                   { return(MathArccos_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathArccos(int value)                                     { return(MathArccos_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathArccos(long value)                                    { return(MathArccos_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathArccos(uchar value)                                   { return(MathArccos_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathArccos(ushort value)                                  { return(MathArccos_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathArccos(uint value)                                    { return(MathArccos_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathArccos(ulong value)                                   { return(MathArccos_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathArccos(float value)                                   { return(MathArccos_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathArccos(double value)                                  { return(MathArccos_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathArccos(const matrix& value)                           { return(MathArccos_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathArccos(const matrixf& value)                          { return(MathArccos_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathArccos(const vector& value)                           { return(MathArccos_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathArccos(const vectorf& value)                          { return(MathArccos_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathArccosh(char value)                                   { return(MathArccosh_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathArccosh(short value )                                 { return(MathArccosh_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathArccosh(int value)                                    { return(MathArccosh_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathArccosh(long value)                                   { return(MathArccosh_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathArccosh(uchar value)                                  { return(MathArccosh_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathArccosh(ushort value)                                 { return(MathArccosh_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathArccosh(uint value)                                   { return(MathArccosh_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathArccosh(ulong value)                                  { return(MathArccosh_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathArccosh(float value)                                  { return(MathArccosh_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathArccosh(double value)                                 { return(MathArccosh_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathArccosh(const matrix& value)                          { return(MathArccosh_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathArccosh(const matrixf& value)                         { return(MathArccosh_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathArccosh(const vector& value)                          { return(MathArccosh_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathArccosh(const vectorf& value)                         { return(MathArccosh_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsin(char value)                                    { return(MathArcsin_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsin(short value)                                   { return(MathArcsin_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsin(int value)                                     { return(MathArcsin_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsin(long value)                                    { return(MathArcsin_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsin(uchar value)                                   { return(MathArcsin_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsin(ushort value)                                  { return(MathArcsin_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsin(uint value)                                    { return(MathArcsin_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsin(ulong value)                                   { return(MathArcsin_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathArcsin(float value)                                   { return(MathArcsin_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsin(double value)                                  { return(MathArcsin_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathArcsin(const matrix& value)                           { return(MathArcsin_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathArcsin(const matrixf& value)                          { return(MathArcsin_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathArcsin(const vector& value)                           { return(MathArcsin_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathArcsin(const vectorf& value)                          { return(MathArcsin_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsinh(char value)                                   { return(MathArcsinh_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsinh(short value )                                 { return(MathArcsinh_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsinh(int value)                                    { return(MathArcsinh_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsinh(long value)                                   { return(MathArcsinh_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsinh(uchar value)                                  { return(MathArcsinh_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsinh(ushort value)                                 { return(MathArcsinh_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsinh(uint value)                                   { return(MathArcsinh_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsinh(ulong value)                                  { return(MathArcsinh_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathArcsinh(float value)                                  { return(MathArcsinh_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathArcsinh(double value)                                 { return(MathArcsinh_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathArcsinh(const matrix& value)                          { return(MathArcsinh_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathArcsinh(const matrixf& value)                         { return(MathArcsinh_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathArcsinh(const vector& value)                          { return(MathArcsinh_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathArcsinh(const vectorf& value)                         { return(MathArcsinh_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathArctan(char value)                                    { return(MathArctan_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathArctan(short value)                                   { return(MathArctan_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathArctan(int value)                                     { return(MathArctan_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathArctan(long value)                                    { return(MathArctan_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathArctan(uchar value)                                   { return(MathArctan_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathArctan(ushort value)                                  { return(MathArctan_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathArctan(uint value)                                    { return(MathArctan_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathArctan(ulong value)                                   { return(MathArctan_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathArctan(float value)                                   { return(MathArctan_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathArctan(double value)                                  { return(MathArctan_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathArctan(const matrix& value)                           { return(MathArctan_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathArctan(const matrixf& value)                          { return(MathArctan_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathArctan(const vector& value)                           { return(MathArctan_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathArctan(const vectorf& value)                          { return(MathArctan_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathArctan2(char value, char value2)                      { return(MathArctan2_T<double, char, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(char value, double value2)                    { return(MathArctan2_T<double, char, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(char value, float value2)                     { return(MathArctan2_T<double, char, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(char value, int value2)                       { return(MathArctan2_T<double, char, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(char value, long value2)                      { return(MathArctan2_T<double, char, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(char value, short value2)                     { return(MathArctan2_T<double, char, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(char value, uchar value2)                     { return(MathArctan2_T<double, char, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(char value, uint value2)                      { return(MathArctan2_T<double, char, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(char value, ulong value2)                     { return(MathArctan2_T<double, char, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(char value, ushort value2)                    { return(MathArctan2_T<double, char, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(double value, char value2)                    { return(MathArctan2_T<double, double, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(double value, double value2)                  { return(MathArctan2_T<double, double, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(double value, float value2)                   { return(MathArctan2_T<double, double, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(double value, int value2)                     { return(MathArctan2_T<double, double, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(double value, long value2)                    { return(MathArctan2_T<double, double, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(double value, short value2)                   { return(MathArctan2_T<double, double, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(double value, uchar value2)                   { return(MathArctan2_T<double, double, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(double value, uint value2)                    { return(MathArctan2_T<double, double, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(double value, ulong value2)                   { return(MathArctan2_T<double, double, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(double value, ushort value2)                  { return(MathArctan2_T<double, double, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(int value, char value2)                       { return(MathArctan2_T<double, int, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(int value, double value2)                     { return(MathArctan2_T<double, int, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(int value, float value2)                      { return(MathArctan2_T<double, int, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(int value, int value2)                        { return(MathArctan2_T<double, int, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(int value, long value2)                       { return(MathArctan2_T<double, int, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(int value, short value2)                      { return(MathArctan2_T<double, int, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(int value, uchar value2)                      { return(MathArctan2_T<double, int, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(int value, uint value2)                       { return(MathArctan2_T<double, int, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(int value, ulong value2)                      { return(MathArctan2_T<double, int, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(int value, ushort value2)                     { return(MathArctan2_T<double, int, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(long value, char value2)                      { return(MathArctan2_T<double, long, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(long value, double value2)                    { return(MathArctan2_T<double, long, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(long value, float value2)                     { return(MathArctan2_T<double, long, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(long value, int value2)                       { return(MathArctan2_T<double, long, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(long value, long value2)                      { return(MathArctan2_T<double, long, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(long value, short value2)                     { return(MathArctan2_T<double, long, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(long value, uchar value2)                     { return(MathArctan2_T<double, long, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(long value, uint value2)                      { return(MathArctan2_T<double, long, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(long value, ulong value2)                     { return(MathArctan2_T<double, long, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(long value, ushort value2)                    { return(MathArctan2_T<double, long, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(short value, char value2)                     { return(MathArctan2_T<double, short, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(short value, double value2)                   { return(MathArctan2_T<double, short, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(short value, float value2)                    { return(MathArctan2_T<double, short, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(short value, int value2)                      { return(MathArctan2_T<double, short, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(short value, long value2)                     { return(MathArctan2_T<double, short, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(short value, short value2)                    { return(MathArctan2_T<double, short, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(short value, uchar value2)                    { return(MathArctan2_T<double, short, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(short value, uint value2)                     { return(MathArctan2_T<double, short, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(short value, ulong value2)                    { return(MathArctan2_T<double, short, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(short value, ushort value2)                   { return(MathArctan2_T<double, short, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uchar value, char value2)                     { return(MathArctan2_T<double, uchar, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uchar value, double value2)                   { return(MathArctan2_T<double, uchar, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uchar value, float value2)                    { return(MathArctan2_T<double, uchar, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uchar value, int value2)                      { return(MathArctan2_T<double, uchar, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uchar value, long value2)                     { return(MathArctan2_T<double, uchar, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uchar value, short value2)                    { return(MathArctan2_T<double, uchar, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uchar value, uchar value2)                    { return(MathArctan2_T<double, uchar, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uchar value, uint value2)                     { return(MathArctan2_T<double, uchar, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uchar value, ulong value2)                    { return(MathArctan2_T<double, uchar, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uchar value, ushort value2)                   { return(MathArctan2_T<double, uchar, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uint value, char value2)                      { return(MathArctan2_T<double, uint, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uint value, double value2)                    { return(MathArctan2_T<double, uint, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uint value, float value2)                     { return(MathArctan2_T<double, uint, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uint value, int value2)                       { return(MathArctan2_T<double, uint, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uint value, long value2)                      { return(MathArctan2_T<double, uint, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uint value, short value2)                     { return(MathArctan2_T<double, uint, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uint value, uchar value2)                     { return(MathArctan2_T<double, uint, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uint value, uint value2)                      { return(MathArctan2_T<double, uint, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uint value, ulong value2)                     { return(MathArctan2_T<double, uint, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(uint value, ushort value2)                    { return(MathArctan2_T<double, uint, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ulong value, char value2)                     { return(MathArctan2_T<double, ulong, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ulong value, double value2)                   { return(MathArctan2_T<double, ulong, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ulong value, float value2)                    { return(MathArctan2_T<double, ulong, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ulong value, int value2)                      { return(MathArctan2_T<double, ulong, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ulong value, long value2)                     { return(MathArctan2_T<double, ulong, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ulong value, short value2)                    { return(MathArctan2_T<double, ulong, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ulong value, uchar value2)                    { return(MathArctan2_T<double, ulong, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ulong value, uint value2)                     { return(MathArctan2_T<double, ulong, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ulong value, ulong value2)                    { return(MathArctan2_T<double, ulong, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ulong value, ushort value2)                   { return(MathArctan2_T<double, ulong, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ushort value, char value2)                    { return(MathArctan2_T<double, ushort, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ushort value, double value2)                  { return(MathArctan2_T<double, ushort, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ushort value, float value2)                   { return(MathArctan2_T<double, ushort, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ushort value, int value2)                     { return(MathArctan2_T<double, ushort, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ushort value, long value2)                    { return(MathArctan2_T<double, ushort, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ushort value, short value2)                   { return(MathArctan2_T<double, ushort, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ushort value, uchar value2)                   { return(MathArctan2_T<double, ushort, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ushort value, uint value2)                    { return(MathArctan2_T<double, ushort, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ushort value, ulong value2)                   { return(MathArctan2_T<double, ushort, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(ushort value, ushort value2)                  { return(MathArctan2_T<double, ushort, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(float value, char value2)                     { return(MathArctan2_T<double, float, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(float value, float value2)                    { return(MathArctan2_T<double, float, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(float value, int value2)                      { return(MathArctan2_T<double, float, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(float value, long value2)                     { return(MathArctan2_T<double, float, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(float value, short value2)                    { return(MathArctan2_T<double, float, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(float value, uchar value2)                    { return(MathArctan2_T<double, float, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(float value, ulong value2)                    { return(MathArctan2_T<double, float, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctan2(float value, ushort value2)                   { return(MathArctan2_T<double, float, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathArctanh(char value)                                   { return(MathArctanh_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathArctanh(short value )                                 { return(MathArctanh_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathArctanh(int value)                                    { return(MathArctanh_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathArctanh(long value)                                   { return(MathArctanh_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathArctanh(uchar value)                                  { return(MathArctanh_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathArctanh(ushort value)                                 { return(MathArctanh_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathArctanh(uint value)                                   { return(MathArctanh_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathArctanh(ulong value)                                  { return(MathArctanh_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathArctanh(float value)                                  { return(MathArctanh_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathArctanh(double value)                                 { return(MathArctanh_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathArctanh(const matrix& value)                          { return(MathArctanh_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathArctanh(const matrixf& value)                         { return(MathArctanh_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathArctanh(const vector& value)                          { return(MathArctanh_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathArctanh(const vectorf& value)                         { return(MathArctanh_T<vectorf, vectorf>(value)); }
            ENUM_FP_CLASS dbg_mqlapi_trace_func_MathClassify(double value)      
            {       
                ENUM_FP_CLASS retval;       
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));      
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;       
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);       
                DBG_MQLAPI_TRACE_FUNC_BEFORE;       
                retval = ::MathClassify(value);       
                DBG_MQLAPI_TRACE_FUNC_AFTER;        
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;        
                return(retval);     
            };      
            double      dbg_mqlapi_trace_func_MathCeil(char value)                                      { return(MathCeil_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathCeil(short value)                                     { return(MathCeil_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathCeil(int value)                                       { return(MathCeil_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathCeil(long value)                                      { return(MathCeil_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathCeil(uchar value)                                     { return(MathCeil_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathCeil(ushort value)                                    { return(MathCeil_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathCeil(uint value)                                      { return(MathCeil_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathCeil(ulong value)                                     { return(MathCeil_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathCeil(float value)                                     { return(MathCeil_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathCeil(double value)                                    { return(MathCeil_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathCeil(const matrix& value)                             { return(MathCeil_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathCeil(const matrixf& value)                            { return(MathCeil_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathCeil(const vector& value)                             { return(MathCeil_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathCeil(const vectorf& value)                            { return(MathCeil_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathCos(char value )                                      { return(MathCos_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathCos(short value )                                     { return(MathCos_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathCos(int value)                                        { return(MathCos_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathCos(long value)                                       { return(MathCos_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathCos(uchar value)                                      { return(MathCos_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathCos(ushort value)                                     { return(MathCos_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathCos(uint value)                                       { return(MathCos_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathCos(ulong value)                                      { return(MathCos_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathCos(float value)                                      { return(MathCos_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathCos(double value)                                     { return(MathCos_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathCos(const matrix& value)                              { return(MathCos_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathCos(const matrixf& value)                             { return(MathCos_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathCos(const vector& value)                              { return(MathCos_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathCos(const vectorf& value)                             { return(MathCos_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathCosh(char value )                                     { return(MathCosh_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathCosh(short value )                                    { return(MathCosh_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathCosh(int value)                                       { return(MathCosh_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathCosh(long value)                                      { return(MathCosh_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathCosh(uchar value)                                     { return(MathCosh_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathCosh(ushort value)                                    { return(MathCosh_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathCosh(uint value)                                      { return(MathCosh_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathCosh(ulong value)                                     { return(MathCosh_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathCosh(float value)                                     { return(MathCosh_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathCosh(double value)                                    { return(MathCosh_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathCosh(const matrix& value)                             { return(MathCosh_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathCosh(const matrixf& value)                            { return(MathCosh_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathCosh(const vector& value)                             { return(MathCosh_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathCosh(const vectorf& value)                            { return(MathCosh_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathExp(char value)                                       { return(MathExp_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathExp(short value)                                      { return(MathExp_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathExp(int value)                                        { return(MathExp_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathExp(long value)                                       { return(MathExp_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathExp(uchar value)                                      { return(MathExp_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathExp(ushort value)                                     { return(MathExp_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathExp(uint value)                                       { return(MathExp_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathExp(ulong value)                                      { return(MathExp_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathExp(float value)                                      { return(MathExp_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathExp(double value)                                     { return(MathExp_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathExp(const matrix& value)                              { return(MathExp_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathExp(const matrixf& value)                             { return(MathExp_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathExp(const vector& value)                              { return(MathExp_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathExp(const vectorf& value)                             { return(MathExp_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathExpm1(char value)                                     { return(MathExpm1_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathExpm1(short value)                                    { return(MathExpm1_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathExpm1(int value)                                      { return(MathExpm1_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathExpm1(long value)                                     { return(MathExpm1_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathExpm1(uchar value)                                    { return(MathExpm1_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathExpm1(ushort value)                                   { return(MathExpm1_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathExpm1(uint value)                                     { return(MathExpm1_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathExpm1(ulong value)                                    { return(MathExpm1_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathExpm1(float value)                                    { return(MathExpm1_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathExpm1(double value)                                   { return(MathExpm1_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathExpm1(const matrix& value)                            { return(MathExpm1_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathExpm1(const matrixf& value)                           { return(MathExpm1_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathExpm1(const vector& value)                            { return(MathExpm1_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathExpm1(const vectorf& value)                           { return(MathExpm1_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathFloor(char value)                                     { return(MathFloor_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathFloor(short value)                                    { return(MathFloor_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathFloor(int value)                                      { return(MathFloor_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathFloor(long value)                                     { return(MathFloor_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathFloor(uchar value)                                    { return(MathFloor_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathFloor(ushort value)                                   { return(MathFloor_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathFloor(uint value)                                     { return(MathFloor_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathFloor(ulong value)                                    { return(MathFloor_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathFloor(float value)                                    { return(MathFloor_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathFloor(double value)                                   { return(MathFloor_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathFloor(const matrix& value)                            { return(MathFloor_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathFloor(const matrixf& value)                           { return(MathFloor_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathFloor(const vector& value)                            { return(MathFloor_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathFloor(const vectorf& value)                           { return(MathFloor_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathLog(char value)                                       { return(MathLog_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathLog(short value)                                      { return(MathLog_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathLog(int value)                                        { return(MathLog_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathLog(long value)                                       { return(MathLog_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathLog(uchar value)                                      { return(MathLog_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathLog(ushort value)                                     { return(MathLog_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathLog(uint value)                                       { return(MathLog_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathLog(ulong value)                                      { return(MathLog_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathLog(float value)                                      { return(MathLog_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathLog(double value)                                     { return(MathLog_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathLog(const matrix& value)                              { return(MathLog_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathLog(const matrixf& value)                             { return(MathLog_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathLog(const vector& value)                              { return(MathLog_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathLog(const vectorf& value)                             { return(MathLog_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathLog10(char value)                                     { return(MathLog10_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathLog10(short value)                                    { return(MathLog10_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathLog10(int value)                                      { return(MathLog10_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathLog10(long value)                                     { return(MathLog10_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathLog10(uchar value)                                    { return(MathLog10_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathLog10(ushort value)                                   { return(MathLog10_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathLog10(uint value)                                     { return(MathLog10_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathLog10(ulong value)                                    { return(MathLog10_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathLog10(float value)                                    { return(MathLog10_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathLog10(double value)                                   { return(MathLog10_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathLog10(const matrix& value)                            { return(MathLog10_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathLog10(const matrixf& value)                           { return(MathLog10_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathLog10(const vector& value)                            { return(MathLog10_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathLog10(const vectorf& value)                           { return(MathLog10_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathLog1p(char value)                                     { return(MathLog1p_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathLog1p(short value)                                    { return(MathLog1p_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathLog1p(int value)                                      { return(MathLog1p_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathLog1p(long value)                                     { return(MathLog1p_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathLog1p(uchar value)                                    { return(MathLog1p_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathLog1p(ushort value)                                   { return(MathLog1p_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathLog1p(uint value)                                     { return(MathLog1p_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathLog1p(ulong value)                                    { return(MathLog1p_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathLog1p(float value)                                    { return(MathLog1p_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathLog1p(double value)                                   { return(MathLog1p_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathLog1p(const matrix& value)                            { return(MathLog1p_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathLog1p(const matrixf& value)                           { return(MathLog1p_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathLog1p(const vector& value)                            { return(MathLog1p_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathLog1p(const vectorf& value)                           { return(MathLog1p_T<vectorf, vectorf>(value)); }
        //                                  float  dbg_mqlapi_trace_func_MathMod(float value, uint value2)                                                                                                                                                                               { float retval; _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));    DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;       DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, value2, 0, 0, 0, 0, 0);                 DBG_MQLAPI_TRACE_FUNC_BEFORE;                retval = ::MathMod(value, value2);                                                                                                                                                                                                                                                                                                                                                      DBG_MQLAPI_TRACE_FUNC_AFTER;                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE; return(retval); }
            double      dbg_mqlapi_trace_func_MathMod(char value, char value2)                          { return(MathMod_T<double, char, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(char value, double value2)                        { return(MathMod_T<double, char, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(char value, float value2)                         { return(MathMod_T<double, char, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(char value, int value2)                           { return(MathMod_T<double, char, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(char value, long value2)                          { return(MathMod_T<double, char, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(char value, short value2)                         { return(MathMod_T<double, char, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(char value, uchar value2)                         { return(MathMod_T<double, char, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(char value, uint value2)                          { return(MathMod_T<double, char, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(char value, ulong value2)                         { return(MathMod_T<double, char, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(char value, ushort value2)                        { return(MathMod_T<double, char, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(double value, char value2)                        { return(MathMod_T<double, double, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(double value, double value2)                      { return(MathMod_T<double, double, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(double value, float value2)                       { return(MathMod_T<double, double, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(double value, int value2)                         { return(MathMod_T<double, double, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(double value, long value2)                        { return(MathMod_T<double, double, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(double value, short value2)                       { return(MathMod_T<double, double, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(double value, uchar value2)                       { return(MathMod_T<double, double, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(double value, uint value2)                        { return(MathMod_T<double, double, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(double value, ulong value2)                       { return(MathMod_T<double, double, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(double value, ushort value2)                      { return(MathMod_T<double, double, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(int value, char value2)                           { return(MathMod_T<double, int, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(int value, double value2)                         { return(MathMod_T<double, int, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(int value, float value2)                          { return(MathMod_T<double, int, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(int value, int value2)                            { return(MathMod_T<double, int, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(int value, long value2)                           { return(MathMod_T<double, int, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(int value, short value2)                          { return(MathMod_T<double, int, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(int value, uchar value2)                          { return(MathMod_T<double, int, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(int value, uint value2)                           { return(MathMod_T<double, int, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(int value, ulong value2)                          { return(MathMod_T<double, int, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(int value, ushort value2)                         { return(MathMod_T<double, int, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(long value, char value2)                          { return(MathMod_T<double, long, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(long value, double value2)                        { return(MathMod_T<double, long, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(long value, float value2)                         { return(MathMod_T<double, long, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(long value, int value2)                           { return(MathMod_T<double, long, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(long value, long value2)                          { return(MathMod_T<double, long, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(long value, short value2)                         { return(MathMod_T<double, long, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(long value, uchar value2)                         { return(MathMod_T<double, long, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(long value, uint value2)                          { return(MathMod_T<double, long, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(long value, ulong value2)                         { return(MathMod_T<double, long, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(long value, ushort value2)                        { return(MathMod_T<double, long, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(short value, char value2)                         { return(MathMod_T<double, short, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(short value, double value2)                       { return(MathMod_T<double, short, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(short value, float value2)                        { return(MathMod_T<double, short, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(short value, int value2)                          { return(MathMod_T<double, short, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(short value, long value2)                         { return(MathMod_T<double, short, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(short value, short value2)                        { return(MathMod_T<double, short, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(short value, uchar value2)                        { return(MathMod_T<double, short, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(short value, uint value2)                         { return(MathMod_T<double, short, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(short value, ulong value2)                        { return(MathMod_T<double, short, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(short value, ushort value2)                       { return(MathMod_T<double, short, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uchar value, char value2)                         { return(MathMod_T<double, uchar, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uchar value, double value2)                       { return(MathMod_T<double, uchar, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uchar value, float value2)                        { return(MathMod_T<double, uchar, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uchar value, int value2)                          { return(MathMod_T<double, uchar, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uchar value, long value2)                         { return(MathMod_T<double, uchar, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uchar value, short value2)                        { return(MathMod_T<double, uchar, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uchar value, uchar value2)                        { return(MathMod_T<double, uchar, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uchar value, uint value2)                         { return(MathMod_T<double, uchar, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uchar value, ulong value2)                        { return(MathMod_T<double, uchar, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uchar value, ushort value2)                       { return(MathMod_T<double, uchar, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uint value, char value2)                          { return(MathMod_T<double, uint, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uint value, double value2)                        { return(MathMod_T<double, uint, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uint value, float value2)                         { return(MathMod_T<double, uint, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uint value, int value2)                           { return(MathMod_T<double, uint, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uint value, long value2)                          { return(MathMod_T<double, uint, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uint value, short value2)                         { return(MathMod_T<double, uint, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uint value, uchar value2)                         { return(MathMod_T<double, uint, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uint value, uint value2)                          { return(MathMod_T<double, uint, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uint value, ulong value2)                         { return(MathMod_T<double, uint, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(uint value, ushort value2)                        { return(MathMod_T<double, uint, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ulong value, char value2)                         { return(MathMod_T<double, ulong, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ulong value, double value2)                       { return(MathMod_T<double, ulong, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ulong value, float value2)                        { return(MathMod_T<double, ulong, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ulong value, int value2)                          { return(MathMod_T<double, ulong, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ulong value, long value2)                         { return(MathMod_T<double, ulong, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ulong value, short value2)                        { return(MathMod_T<double, ulong, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ulong value, uchar value2)                        { return(MathMod_T<double, ulong, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ulong value, uint value2)                         { return(MathMod_T<double, ulong, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ulong value, ulong value2)                        { return(MathMod_T<double, ulong, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ulong value, ushort value2)                       { return(MathMod_T<double, ulong, ushort>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ushort value, char value2)                        { return(MathMod_T<double, ushort, char>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ushort value, double value2)                      { return(MathMod_T<double, ushort, double>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ushort value, float value2)                       { return(MathMod_T<double, ushort, float>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ushort value, int value2)                         { return(MathMod_T<double, ushort, int>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ushort value, long value2)                        { return(MathMod_T<double, ushort, long>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ushort value, short value2)                       { return(MathMod_T<double, ushort, short>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ushort value, uchar value2)                       { return(MathMod_T<double, ushort, uchar>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ushort value, uint value2)                        { return(MathMod_T<double, ushort, uint>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ushort value, ulong value2)                       { return(MathMod_T<double, ushort, ulong>(value, value2)); }
            double      dbg_mqlapi_trace_func_MathMod(ushort value, ushort value2)                      { return(MathMod_T<double, ushort, ushort>(value, value2)); }
            float       dbg_mqlapi_trace_func_MathMod(float value, char value2)                         { return(MathMod_T<float, float, char>(value, value2)); }
            float       dbg_mqlapi_trace_func_MathMod(float value, float value2)                        { return(MathMod_T<float, float, float>(value, value2)); }
            float       dbg_mqlapi_trace_func_MathMod(float value, int value2)                          { return(MathMod_T<float, float, int>(value, value2)); }
            float       dbg_mqlapi_trace_func_MathMod(float value, long value2)                         { return(MathMod_T<float, float, long>(value, value2)); }
            float       dbg_mqlapi_trace_func_MathMod(float value, short value2)                        { return(MathMod_T<float, float, short>(value, value2)); }
            float       dbg_mqlapi_trace_func_MathMod(float value, uchar value2)                        { return(MathMod_T<float, float, uchar>(value, value2)); }
            float       dbg_mqlapi_trace_func_MathMod(float value, ulong value2)                        { return(MathMod_T<float, float, ulong>(value, value2)); }
            float       dbg_mqlapi_trace_func_MathMod(float value, ushort value2)                       { return(MathMod_T<float, float, ushort>(value, value2)); }
            matrix      dbg_mqlapi_trace_func_MathMod(const matrix& value, char value2)                 { return(MathMod_T<matrix, matrix, char>(value, value2)); }
            matrix      dbg_mqlapi_trace_func_MathMod(const matrix& value, double value2)               { return(MathMod_T<matrix, matrix, double>(value, value2)); }
            matrix      dbg_mqlapi_trace_func_MathMod(const matrix& value, float value2)                { return(MathMod_T<matrix, matrix, float>(value, value2)); }
            matrix      dbg_mqlapi_trace_func_MathMod(const matrix& value, int value2)                  { return(MathMod_T<matrix, matrix, int>(value, value2)); }
            matrix      dbg_mqlapi_trace_func_MathMod(const matrix& value, long value2)                 { return(MathMod_T<matrix, matrix, long>(value, value2)); }
            matrix      dbg_mqlapi_trace_func_MathMod(const matrix& value, const matrix& value2)        { return(MathMod_T<matrix, matrix, matrix>(value, value2)); }
            matrix      dbg_mqlapi_trace_func_MathMod(const matrix& value, short value2)                { return(MathMod_T<matrix, matrix, short>(value, value2)); }
            matrix      dbg_mqlapi_trace_func_MathMod(const matrix& value, uchar value2)                { return(MathMod_T<matrix, matrix, uchar>(value, value2)); }
            matrix      dbg_mqlapi_trace_func_MathMod(const matrix& value, uint value2)                 { return(MathMod_T<matrix, matrix, uint>(value, value2)); }
            matrix      dbg_mqlapi_trace_func_MathMod(const matrix& value, ulong value2)                { return(MathMod_T<matrix, matrix, ulong>(value, value2)); }
            matrix      dbg_mqlapi_trace_func_MathMod(const matrix& value, ushort value2)               { return(MathMod_T<matrix, matrix, ushort>(value, value2)); }
            matrixf     dbg_mqlapi_trace_func_MathMod(const matrixf& value, char value2)                { return(MathMod_T<matrixf, matrixf, char>(value, value2)); }
            matrixf     dbg_mqlapi_trace_func_MathMod(const matrixf& value, float value2)               { return(MathMod_T<matrixf, matrixf, float>(value, value2)); }
            matrixf     dbg_mqlapi_trace_func_MathMod(const matrixf& value, int value2)                 { return(MathMod_T<matrixf, matrixf, int>(value, value2)); }
            matrixf     dbg_mqlapi_trace_func_MathMod(const matrixf& value, long value2)                { return(MathMod_T<matrixf, matrixf, long>(value, value2)); }
            matrixf     dbg_mqlapi_trace_func_MathMod(const matrixf& value, const matrixf& value2)      { return(MathMod_T<matrixf, matrixf, matrixf>(value, value2)); }
            matrixf     dbg_mqlapi_trace_func_MathMod(const matrixf& value, short value2)               { return(MathMod_T<matrixf, matrixf, short>(value, value2)); }
            matrixf     dbg_mqlapi_trace_func_MathMod(const matrixf& value, uchar value2)               { return(MathMod_T<matrixf, matrixf, uchar>(value, value2)); }
            matrixf     dbg_mqlapi_trace_func_MathMod(const matrixf& value, uint value2)                { return(MathMod_T<matrixf, matrixf, uint>(value, value2)); }
            matrixf     dbg_mqlapi_trace_func_MathMod(const matrixf& value, ulong value2)               { return(MathMod_T<matrixf, matrixf, ulong>(value, value2)); }
            matrixf     dbg_mqlapi_trace_func_MathMod(const matrixf& value, ushort value2)              { return(MathMod_T<matrixf, matrixf, ushort>(value, value2)); }
            vector      dbg_mqlapi_trace_func_MathMod(const vector& value, char value2)                 { return(MathMod_T<vector, vector, char>(value, value2)); }
            vector      dbg_mqlapi_trace_func_MathMod(const vector& value, double value2)               { return(MathMod_T<vector, vector, double>(value, value2)); }
            vector      dbg_mqlapi_trace_func_MathMod(const vector& value, float value2)                { return(MathMod_T<vector, vector, float>(value, value2)); }
            vector      dbg_mqlapi_trace_func_MathMod(const vector& value, int value2)                  { return(MathMod_T<vector, vector, int>(value, value2)); }
            vector      dbg_mqlapi_trace_func_MathMod(const vector& value, long value2)                 { return(MathMod_T<vector, vector, long>(value, value2)); }
            vector      dbg_mqlapi_trace_func_MathMod(const vector& value, short value2)                { return(MathMod_T<vector, vector, short>(value, value2)); }
            vector      dbg_mqlapi_trace_func_MathMod(const vector& value, uchar value2)                { return(MathMod_T<vector, vector, uchar>(value, value2)); }
            vector      dbg_mqlapi_trace_func_MathMod(const vector& value, uint value2)                 { return(MathMod_T<vector, vector, uint>(value, value2)); }
            vector      dbg_mqlapi_trace_func_MathMod(const vector& value, ulong value2)                { return(MathMod_T<vector, vector, ulong>(value, value2)); }
            vector      dbg_mqlapi_trace_func_MathMod(const vector& value, ushort value2)               { return(MathMod_T<vector, vector, ushort>(value, value2)); }
            vector      dbg_mqlapi_trace_func_MathMod(const vector& value, const vector& value2)        { return(MathMod_T<vector, vector, vector>(value, value2)); }
            vectorf     dbg_mqlapi_trace_func_MathMod(const vectorf& value, char value2)                { return(MathMod_T<vectorf, vectorf, char>(value, value2)); }
            vectorf     dbg_mqlapi_trace_func_MathMod(const vectorf& value, float value2)               { return(MathMod_T<vectorf, vectorf, float>(value, value2)); }
            vectorf     dbg_mqlapi_trace_func_MathMod(const vectorf& value, int value2)                 { return(MathMod_T<vectorf, vectorf, int>(value, value2)); }
            vectorf     dbg_mqlapi_trace_func_MathMod(const vectorf& value, long value2)                { return(MathMod_T<vectorf, vectorf, long>(value, value2)); }
            vectorf     dbg_mqlapi_trace_func_MathMod(const vectorf& value, short value2)               { return(MathMod_T<vectorf, vectorf, short>(value, value2)); }
            vectorf     dbg_mqlapi_trace_func_MathMod(const vectorf& value, uchar value2)               { return(MathMod_T<vectorf, vectorf, uchar>(value, value2)); }
            vectorf     dbg_mqlapi_trace_func_MathMod(const vectorf& value, uint value2)                { return(MathMod_T<vectorf, vectorf, uint>(value, value2)); }
            vectorf     dbg_mqlapi_trace_func_MathMod(const vectorf& value, ulong value2)               { return(MathMod_T<vectorf, vectorf, ulong>(value, value2)); }
            vectorf     dbg_mqlapi_trace_func_MathMod(const vectorf& value, ushort value2)              { return(MathMod_T<vectorf, vectorf, ushort>(value, value2)); }
            vectorf     dbg_mqlapi_trace_func_MathMod(const vectorf& value, const vectorf& value2)      { return(MathMod_T<vectorf, vectorf, vectorf>(value, value2)); }
        //                                  float  dbg_mqlapi_trace_func_MathPow(float base, uint exponent)                                                                                                                                                                              { float retval; _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));    DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;       DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, base, exponent, 0, 0, 0, 0, 0);                 DBG_MQLAPI_TRACE_FUNC_BEFORE;                retval = ::MathPow(base, exponent);                                                                                                                                                                                                                                                                                                                                                     DBG_MQLAPI_TRACE_FUNC_AFTER;                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE; return(retval); }
            double      dbg_mqlapi_trace_func_MathPow(char base, char exponent)                         { return(MathPow_T<double, char, char>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(char base, double exponent)                       { return(MathPow_T<double, char, double>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(char base, float exponent)                        { return(MathPow_T<double, char, float>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(char base, int exponent)                          { return(MathPow_T<double, char, int>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(char base, long exponent)                         { return(MathPow_T<double, char, long>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(char base, short exponent)                        { return(MathPow_T<double, char, short>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(char base, uchar exponent)                        { return(MathPow_T<double, char, uchar>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(char base, uint exponent)                         { return(MathPow_T<double, char, uint>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(char base, ulong exponent)                        { return(MathPow_T<double, char, ulong>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(char base, ushort exponent)                       { return(MathPow_T<double, char, ushort>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(double base, char exponent)                       { return(MathPow_T<double, double, char>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(double base, double exponent)                     { return(MathPow_T<double, double, double>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(double base, float exponent)                      { return(MathPow_T<double, double, float>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(double base, int exponent)                        { return(MathPow_T<double, double, int>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(double base, long exponent)                       { return(MathPow_T<double, double, long>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(double base, short exponent)                      { return(MathPow_T<double, double, short>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(double base, uchar exponent)                      { return(MathPow_T<double, double, uchar>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(double base, uint exponent)                       { return(MathPow_T<double, double, uint>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(double base, ulong exponent)                      { return(MathPow_T<double, double, ulong>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(double base, ushort exponent)                     { return(MathPow_T<double, double, ushort>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(int base, char exponent)                          { return(MathPow_T<double, int, char>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(int base, double exponent)                        { return(MathPow_T<double, int, double>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(int base, float exponent)                         { return(MathPow_T<double, int, float>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(int base, int exponent)                           { return(MathPow_T<double, int, int>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(int base, long exponent)                          { return(MathPow_T<double, int, long>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(int base, short exponent)                         { return(MathPow_T<double, int, short>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(int base, uchar exponent)                         { return(MathPow_T<double, int, uchar>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(int base, uint exponent)                          { return(MathPow_T<double, int, uint>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(int base, ulong exponent)                         { return(MathPow_T<double, int, ulong>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(int base, ushort exponent)                        { return(MathPow_T<double, int, ushort>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(long base, char exponent)                         { return(MathPow_T<double, long, char>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(long base, double exponent)                       { return(MathPow_T<double, long, double>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(long base, float exponent)                        { return(MathPow_T<double, long, float>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(long base, int exponent)                          { return(MathPow_T<double, long, int>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(long base, long exponent)                         { return(MathPow_T<double, long, long>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(long base, short exponent)                        { return(MathPow_T<double, long, short>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(long base, uchar exponent)                        { return(MathPow_T<double, long, uchar>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(long base, uint exponent)                         { return(MathPow_T<double, long, uint>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(long base, ulong exponent)                        { return(MathPow_T<double, long, ulong>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(long base, ushort exponent)                       { return(MathPow_T<double, long, ushort>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(short base, char exponent)                        { return(MathPow_T<double, short, char>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(short base, double exponent)                      { return(MathPow_T<double, short, double>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(short base, float exponent)                       { return(MathPow_T<double, short, float>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(short base, int exponent)                         { return(MathPow_T<double, short, int>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(short base, long exponent)                        { return(MathPow_T<double, short, long>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(short base, short exponent)                       { return(MathPow_T<double, short, short>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(short base, uchar exponent)                       { return(MathPow_T<double, short, uchar>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(short base, uint exponent)                        { return(MathPow_T<double, short, uint>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(short base, ulong exponent)                       { return(MathPow_T<double, short, ulong>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(short base, ushort exponent)                      { return(MathPow_T<double, short, ushort>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uchar base, char exponent)                        { return(MathPow_T<double, uchar, char>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uchar base, double exponent)                      { return(MathPow_T<double, uchar, double>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uchar base, float exponent)                       { return(MathPow_T<double, uchar, float>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uchar base, int exponent)                         { return(MathPow_T<double, uchar, int>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uchar base, long exponent)                        { return(MathPow_T<double, uchar, long>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uchar base, short exponent)                       { return(MathPow_T<double, uchar, short>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uchar base, uchar exponent)                       { return(MathPow_T<double, uchar, uchar>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uchar base, uint exponent)                        { return(MathPow_T<double, uchar, uint>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uchar base, ulong exponent)                       { return(MathPow_T<double, uchar, ulong>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uchar base, ushort exponent)                      { return(MathPow_T<double, uchar, ushort>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uint base, char exponent)                         { return(MathPow_T<double, uint, char>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uint base, double exponent)                       { return(MathPow_T<double, uint, double>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uint base, float exponent)                        { return(MathPow_T<double, uint, float>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uint base, int exponent)                          { return(MathPow_T<double, uint, int>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uint base, long exponent)                         { return(MathPow_T<double, uint, long>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uint base, short exponent)                        { return(MathPow_T<double, uint, short>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uint base, uchar exponent)                        { return(MathPow_T<double, uint, uchar>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uint base, uint exponent)                         { return(MathPow_T<double, uint, uint>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uint base, ulong exponent)                        { return(MathPow_T<double, uint, ulong>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(uint base, ushort exponent)                       { return(MathPow_T<double, uint, ushort>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ulong base, char exponent)                        { return(MathPow_T<double, ulong, char>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ulong base, double exponent)                      { return(MathPow_T<double, ulong, double>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ulong base, float exponent)                       { return(MathPow_T<double, ulong, float>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ulong base, int exponent)                         { return(MathPow_T<double, ulong, int>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ulong base, long exponent)                        { return(MathPow_T<double, ulong, long>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ulong base, short exponent)                       { return(MathPow_T<double, ulong, short>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ulong base, uchar exponent)                       { return(MathPow_T<double, ulong, uchar>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ulong base, uint exponent)                        { return(MathPow_T<double, ulong, uint>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ulong base, ulong exponent)                       { return(MathPow_T<double, ulong, ulong>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ulong base, ushort exponent)                      { return(MathPow_T<double, ulong, ushort>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ushort base, char exponent)                       { return(MathPow_T<double, ushort, char>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ushort base, double exponent)                     { return(MathPow_T<double, ushort, double>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ushort base, float exponent)                      { return(MathPow_T<double, ushort, float>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ushort base, int exponent)                        { return(MathPow_T<double, ushort, int>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ushort base, long exponent)                       { return(MathPow_T<double, ushort, long>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ushort base, short exponent)                      { return(MathPow_T<double, ushort, short>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ushort base, uchar exponent)                      { return(MathPow_T<double, ushort, uchar>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ushort base, uint exponent)                       { return(MathPow_T<double, ushort, uint>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ushort base, ulong exponent)                      { return(MathPow_T<double, ushort, ulong>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathPow(ushort base, ushort exponent)                     { return(MathPow_T<double, ushort, ushort>(base, exponent)); }
            float       dbg_mqlapi_trace_func_MathPow(float base, char exponent)                        { return(MathPow_T<float, float, char>(base, exponent)); }
            float       dbg_mqlapi_trace_func_MathPow(float base, float exponent)                       { return(MathPow_T<float, float, float>(base, exponent)); }
            float       dbg_mqlapi_trace_func_MathPow(float base, int exponent)                         { return(MathPow_T<float, float, int>(base, exponent)); }
            float       dbg_mqlapi_trace_func_MathPow(float base, long exponent)                        { return(MathPow_T<float, float, long>(base, exponent)); }
            float       dbg_mqlapi_trace_func_MathPow(float base, short exponent)                       { return(MathPow_T<float, float, short>(base, exponent)); }
            float       dbg_mqlapi_trace_func_MathPow(float base, uchar exponent)                       { return(MathPow_T<float, float, uchar>(base, exponent)); }
            float       dbg_mqlapi_trace_func_MathPow(float base, ulong exponent)                       { return(MathPow_T<float, float, ulong>(base, exponent)); }
            float       dbg_mqlapi_trace_func_MathPow(float base, ushort exponent)                      { return(MathPow_T<float, float, ushort>(base, exponent)); }
            matrix      dbg_mqlapi_trace_func_MathPow(const matrix& base, char exponent)                { return(MathPow_T<matrix, matrix, char>(base, exponent)); }
            matrix      dbg_mqlapi_trace_func_MathPow(const matrix& base, double exponent)              { return(MathPow_T<matrix, matrix, double>(base, exponent)); }
            matrix      dbg_mqlapi_trace_func_MathPow(const matrix& base, float exponent)               { return(MathPow_T<matrix, matrix, float>(base, exponent)); }
            matrix      dbg_mqlapi_trace_func_MathPow(const matrix& base, int exponent)                 { return(MathPow_T<matrix, matrix, int>(base, exponent)); }
            matrix      dbg_mqlapi_trace_func_MathPow(const matrix& base, long exponent)                { return(MathPow_T<matrix, matrix, long>(base, exponent)); }
            matrix      dbg_mqlapi_trace_func_MathPow(const matrix& base, const matrix& exponent)       { return(MathPow_T<matrix, matrix, matrix>(base, exponent)); }
            matrix      dbg_mqlapi_trace_func_MathPow(const matrix& base, short exponent)               { return(MathPow_T<matrix, matrix, short>(base, exponent)); }
            matrix      dbg_mqlapi_trace_func_MathPow(const matrix& base, uchar exponent)               { return(MathPow_T<matrix, matrix, uchar>(base, exponent)); }
            matrix      dbg_mqlapi_trace_func_MathPow(const matrix& base, uint exponent)                { return(MathPow_T<matrix, matrix, uint>(base, exponent)); }
            matrix      dbg_mqlapi_trace_func_MathPow(const matrix& base, ulong exponent)               { return(MathPow_T<matrix, matrix, ulong>(base, exponent)); }
            matrix      dbg_mqlapi_trace_func_MathPow(const matrix& base, ushort exponent)              { return(MathPow_T<matrix, matrix, ushort>(base, exponent)); }
            matrixf     dbg_mqlapi_trace_func_MathPow(const matrixf& base, char exponent)               { return(MathPow_T<matrixf, matrixf, char>(base, exponent)); }
            matrixf     dbg_mqlapi_trace_func_MathPow(const matrixf& base, float exponent)              { return(MathPow_T<matrixf, matrixf, float>(base, exponent)); }
            matrixf     dbg_mqlapi_trace_func_MathPow(const matrixf& base, int exponent)                { return(MathPow_T<matrixf, matrixf, int>(base, exponent)); }
            matrixf     dbg_mqlapi_trace_func_MathPow(const matrixf& base, long exponent)               { return(MathPow_T<matrixf, matrixf, long>(base, exponent)); }
            matrixf     dbg_mqlapi_trace_func_MathPow(const matrixf& base, const matrixf& exponent)     { return(MathPow_T<matrixf, matrixf, matrixf>(base, exponent)); }
            matrixf     dbg_mqlapi_trace_func_MathPow(const matrixf& base, short exponent)              { return(MathPow_T<matrixf, matrixf, short>(base, exponent)); }
            matrixf     dbg_mqlapi_trace_func_MathPow(const matrixf& base, uchar exponent)              { return(MathPow_T<matrixf, matrixf, uchar>(base, exponent)); }
            matrixf     dbg_mqlapi_trace_func_MathPow(const matrixf& base, uint exponent)               { return(MathPow_T<matrixf, matrixf, uint>(base, exponent)); }
            matrixf     dbg_mqlapi_trace_func_MathPow(const matrixf& base, ulong exponent)              { return(MathPow_T<matrixf, matrixf, ulong>(base, exponent)); }
            matrixf     dbg_mqlapi_trace_func_MathPow(const matrixf& base, ushort exponent)             { return(MathPow_T<matrixf, matrixf, ushort>(base, exponent)); }
            vector      dbg_mqlapi_trace_func_MathPow(const vector& base, char exponent)                { return(MathPow_T<vector, vector, char>(base, exponent)); }
            vector      dbg_mqlapi_trace_func_MathPow(const vector& base, double exponent)              { return(MathPow_T<vector, vector, double>(base, exponent)); }
            vector      dbg_mqlapi_trace_func_MathPow(const vector& base, float exponent)               { return(MathPow_T<vector, vector, float>(base, exponent)); }
            vector      dbg_mqlapi_trace_func_MathPow(const vector& base, int exponent)                 { return(MathPow_T<vector, vector, int>(base, exponent)); }
            vector      dbg_mqlapi_trace_func_MathPow(const vector& base, long exponent)                { return(MathPow_T<vector, vector, long>(base, exponent)); }
            vector      dbg_mqlapi_trace_func_MathPow(const vector& base, short exponent)               { return(MathPow_T<vector, vector, short>(base, exponent)); }
            vector      dbg_mqlapi_trace_func_MathPow(const vector& base, uchar exponent)               { return(MathPow_T<vector, vector, uchar>(base, exponent)); }
            vector      dbg_mqlapi_trace_func_MathPow(const vector& base, uint exponent)                { return(MathPow_T<vector, vector, uint>(base, exponent)); }
            vector      dbg_mqlapi_trace_func_MathPow(const vector& base, ulong exponent)               { return(MathPow_T<vector, vector, ulong>(base, exponent)); }
            vector      dbg_mqlapi_trace_func_MathPow(const vector& base, ushort exponent)              { return(MathPow_T<vector, vector, ushort>(base, exponent)); }
            vector      dbg_mqlapi_trace_func_MathPow(const vector& base, const vector& exponent)       { return(MathPow_T<vector, vector, vector>(base, exponent)); }
            vectorf     dbg_mqlapi_trace_func_MathPow(const vectorf& base, char exponent)               { return(MathPow_T<vectorf, vectorf, char>(base, exponent)); }
            vectorf     dbg_mqlapi_trace_func_MathPow(const vectorf& base, float exponent)              { return(MathPow_T<vectorf, vectorf, float>(base, exponent)); }
            vectorf     dbg_mqlapi_trace_func_MathPow(const vectorf& base, int exponent)                { return(MathPow_T<vectorf, vectorf, int>(base, exponent)); }
            vectorf     dbg_mqlapi_trace_func_MathPow(const vectorf& base, long exponent)               { return(MathPow_T<vectorf, vectorf, long>(base, exponent)); }
            vectorf     dbg_mqlapi_trace_func_MathPow(const vectorf& base, short exponent)              { return(MathPow_T<vectorf, vectorf, short>(base, exponent)); }
            vectorf     dbg_mqlapi_trace_func_MathPow(const vectorf& base, uchar exponent)              { return(MathPow_T<vectorf, vectorf, uchar>(base, exponent)); }
            vectorf     dbg_mqlapi_trace_func_MathPow(const vectorf& base, uint exponent)               { return(MathPow_T<vectorf, vectorf, uint>(base, exponent)); }
            vectorf     dbg_mqlapi_trace_func_MathPow(const vectorf& base, ulong exponent)              { return(MathPow_T<vectorf, vectorf, ulong>(base, exponent)); }
            vectorf     dbg_mqlapi_trace_func_MathPow(const vectorf& base, ushort exponent)             { return(MathPow_T<vectorf, vectorf, ushort>(base, exponent)); }
            vectorf     dbg_mqlapi_trace_func_MathPow(const vectorf& base, const vectorf& exponent)     { return(MathPow_T<vectorf, vectorf, vectorf>(base, exponent)); }
            double      dbg_mqlapi_trace_func_MathRound(char value)                                     { return(MathRound_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathRound(short value)                                    { return(MathRound_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathRound(int value)                                      { return(MathRound_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathRound(long value)                                     { return(MathRound_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathRound(uchar value)                                    { return(MathRound_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathRound(ushort value)                                   { return(MathRound_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathRound(uint value)                                     { return(MathRound_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathRound(ulong value)                                    { return(MathRound_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathRound(float value)                                    { return(MathRound_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathRound(double value)                                   { return(MathRound_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathRound(const matrix& value)                            { return(MathRound_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathRound(const matrixf& value)                           { return(MathRound_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathRound(const vector& value)                            { return(MathRound_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathRound(const vectorf& value)                           { return(MathRound_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathSin(char value)                                       { return(MathSin_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathSin(short value)                                      { return(MathSin_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathSin(int value)                                        { return(MathSin_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathSin(long value)                                       { return(MathSin_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathSin(uchar value)                                      { return(MathSin_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathSin(ushort value)                                     { return(MathSin_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathSin(uint value)                                       { return(MathSin_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathSin(ulong value)                                      { return(MathSin_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathSin(float value)                                      { return(MathSin_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathSin(double value)                                     { return(MathSin_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathSin(const matrix& value)                              { return(MathSin_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathSin(const matrixf& value)                             { return(MathSin_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathSin(const vector& value)                              { return(MathSin_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathSin(const vectorf& value)                             { return(MathSin_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathSinh(char value)                                      { return(MathSinh_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathSinh(short value)                                     { return(MathSinh_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathSinh(int value)                                       { return(MathSinh_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathSinh(long value)                                      { return(MathSinh_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathSinh(uchar value)                                     { return(MathSinh_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathSinh(ushort value)                                    { return(MathSinh_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathSinh(uint value)                                      { return(MathSinh_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathSinh(ulong value)                                     { return(MathSinh_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathSinh(float value)                                     { return(MathSinh_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathSinh(double value)                                    { return(MathSinh_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathSinh(const matrix& value)                             { return(MathSinh_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathSinh(const matrixf& value)                            { return(MathSinh_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathSinh(const vector& value)                             { return(MathSinh_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathSinh(const vectorf& value)                            { return(MathSinh_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathSqrt(char value)                                      { return(MathSqrt_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathSqrt(short value)                                     { return(MathSqrt_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathSqrt(int value)                                       { return(MathSqrt_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathSqrt(long value)                                      { return(MathSqrt_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathSqrt(uchar value)                                     { return(MathSqrt_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathSqrt(ushort value)                                    { return(MathSqrt_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathSqrt(uint value)                                      { return(MathSqrt_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathSqrt(ulong value)                                     { return(MathSqrt_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathSqrt(float value)                                     { return(MathSqrt_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathSqrt(double value)                                    { return(MathSqrt_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathSqrt(const matrix& value)                             { return(MathSqrt_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathSqrt(const matrixf& value)                            { return(MathSqrt_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathSqrt(const vector& value)                             { return(MathSqrt_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathSqrt(const vectorf& value)                            { return(MathSqrt_T<vectorf, vectorf>(value)); }
            ushort dbg_mqlapi_trace_func_MathSwap(ushort value)
            {
                ushort retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathSwap(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            uint dbg_mqlapi_trace_func_MathSwap(uint value)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathSwap(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ulong dbg_mqlapi_trace_func_MathSwap(ulong value)
            {
                ulong retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathSwap(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double      dbg_mqlapi_trace_func_MathTan(char value)                                       { return(MathTan_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathTan(short value)                                      { return(MathTan_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathTan(int value)                                        { return(MathTan_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathTan(long value)                                       { return(MathTan_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathTan(uchar value)                                      { return(MathTan_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathTan(ushort value)                                     { return(MathTan_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathTan(uint value)                                       { return(MathTan_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathTan(ulong value)                                      { return(MathTan_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathTan(float value)                                      { return(MathTan_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathTan(double value)                                     { return(MathTan_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathTan(const matrix& value)                              { return(MathTan_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathTan(const matrixf& value)                             { return(MathTan_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathTan(const vector& value)                              { return(MathTan_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathTan(const vectorf& value)                             { return(MathTan_T<vectorf, vectorf>(value)); }
            double      dbg_mqlapi_trace_func_MathTanh(char value)                                      { return(MathTanh_T<double, char>(value)); }
            double      dbg_mqlapi_trace_func_MathTanh(short value)                                     { return(MathTanh_T<double, short>(value)); }
            double      dbg_mqlapi_trace_func_MathTanh(int value)                                       { return(MathTanh_T<double, int>(value)); }
            double      dbg_mqlapi_trace_func_MathTanh(long value)                                      { return(MathTanh_T<double, long>(value)); }
            double      dbg_mqlapi_trace_func_MathTanh(uchar value)                                     { return(MathTanh_T<double, uchar>(value)); }
            double      dbg_mqlapi_trace_func_MathTanh(ushort value)                                    { return(MathTanh_T<double, ushort>(value)); }
            double      dbg_mqlapi_trace_func_MathTanh(uint value)                                      { return(MathTanh_T<double, uint>(value)); }
            double      dbg_mqlapi_trace_func_MathTanh(ulong value)                                     { return(MathTanh_T<double, ulong>(value)); }
            float       dbg_mqlapi_trace_func_MathTanh(float value)                                     { return(MathTanh_T<float, float>(value)); }
            double      dbg_mqlapi_trace_func_MathTanh(double value)                                    { return(MathTanh_T<double, double>(value)); }
            matrix      dbg_mqlapi_trace_func_MathTanh(const matrix& value)                             { return(MathTanh_T<matrix, matrix>(value)); }
            matrixf     dbg_mqlapi_trace_func_MathTanh(const matrixf& value)                            { return(MathTanh_T<matrixf, matrixf>(value)); }
            vector      dbg_mqlapi_trace_func_MathTanh(const vector& value)                             { return(MathTanh_T<vector, vector>(value)); }
            vectorf     dbg_mqlapi_trace_func_MathTanh(const vectorf& value)                            { return(MathTanh_T<vectorf, vectorf>(value)); }

            long dbg_mqlapi_trace_func_OnnxCreate(string filename, uint flags)       
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool ONNX_DEBUG_LOGS          = ((flags & ENUM_ONNX_FLAGS::ONNX_DEBUG_LOGS) != NULL);
                const bool ONNX_NO_CONVERSION       = ((flags & ENUM_ONNX_FLAGS::ONNX_NO_CONVERSION) != NULL);
                const bool ONNX_COMMON_FOLDER       = ((flags & ENUM_ONNX_FLAGS::ONNX_COMMON_FOLDER) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, flags, filename, ONNX_DEBUG_LOGS, ONNX_NO_CONVERSION, ONNX_COMMON_FOLDER, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OnnxCreate(filename, flags);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(0, 0, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_OnnxCreateFromBuffer(const uchar& buffer[], ulong flags)       
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool ONNX_DEBUG_LOGS          = ((flags & ENUM_ONNX_FLAGS::ONNX_DEBUG_LOGS) != NULL);
                const bool ONNX_NO_CONVERSION       = ((flags & ENUM_ONNX_FLAGS::ONNX_NO_CONVERSION) != NULL);
                const bool ONNX_COMMON_FOLDER       = ((flags & ENUM_ONNX_FLAGS::ONNX_COMMON_FOLDER) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, flags, buffer, ONNX_DEBUG_LOGS, ONNX_NO_CONVERSION, ONNX_COMMON_FOLDER, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OnnxCreateFromBuffer(buffer, flags);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(0, 0, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OnnxRelease(long onnx_handle)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, onnx_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OnnxRelease(onnx_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(0, 0, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_OnnxGetInputCount(long onnx_handle)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, onnx_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OnnxGetInputCount(onnx_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(0, 0, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_OnnxGetOutputCount(long onnx_handle)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, onnx_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OnnxGetOutputCount(onnx_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(0, 0, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_OnnxGetInputName(long onnx_handle, long index)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, index, onnx_handle, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OnnxGetInputName(onnx_handle, index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(0, 0, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_OnnxGetOutputName(long onnx_handle, long index)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, index, onnx_handle, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OnnxGetOutputName(onnx_handle, index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(0, 0, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OnnxGetInputTypeInfo(long onnx_handle, long index, OnnxTypeInfo& typeinfo)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, typeinfo, index, onnx_handle, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OnnxGetInputTypeInfo(onnx_handle, index, typeinfo);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(0, 0, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OnnxGetOutputTypeInfo(long onnx_handle, long index, OnnxTypeInfo& typeinfo)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, typeinfo, index, onnx_handle, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OnnxGetOutputTypeInfo(onnx_handle, index, typeinfo);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(0, 0, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OnnxSetInputShape(long onnx_handle, long input_index, const ulong& shape[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, shape, input_index, onnx_handle, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OnnxSetInputShape(onnx_handle, input_index, shape);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(0, 0, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OnnxSetOutputShape(long onnx_handle, long output_index, const ulong& shape[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, shape, output_index, onnx_handle, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OnnxSetInputShape(onnx_handle, output_index, shape);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(0, 0, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderCalcMargin(ENUM_ORDER_TYPE action, string symbol, double volume, double price, double& margin)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, action, symbol, volume, price, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderCalcMargin(action, symbol, volume, price, margin);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, margin, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderCalcProfit(ENUM_ORDER_TYPE action, string symbol, double volume, double price_open, double price_close, double& profit)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, action, symbol, volume, price_open, price_close, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderCalcProfit(action, symbol, volume, price_open, price_close, profit);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, profit, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderCheck(const MqlTradeRequest& request, MqlTradeCheckResult& result)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, request, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderCheck(request, result);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, result, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ulong dbg_mqlapi_trace_func_OrderGetTicket(int index)
            {
                ulong retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, index, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetTicket(index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderSelect(ulong ticket)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, ticket, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderSelect(ticket);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderSend(const MqlTradeRequest& request, MqlTradeResult& result)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, request, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderSend(request, result);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, result, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderSendAsync(const MqlTradeRequest& request, MqlTradeResult& result)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, request, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderSendAsync(request, result);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, result, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ParameterGetRange(const string name, bool& enable, long& value, long& start, long& step, long& stop)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ParameterGetRange(name, enable, value, start, step, stop);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(5, enable, value, start, step, stop, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ParameterGetRange(const string name, bool& enable, double& value, double& start, double& step, double& stop)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ParameterGetRange(name, enable, value, start, step, stop);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(5, enable, value, start, step, stop, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ParameterSetRange(const string name, bool enable, long value, long start, long step, long stop)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, name, enable, value, start, step, stop, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ParameterSetRange(name, enable, value, start, step, stop);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ParameterSetRange(const string name, bool enable, double value, double start, double step, double stop)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, name, enable, value, start, step, stop, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ParameterSetRange(name, enable, value, start, step, stop);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ENUM_TIMEFRAMES dbg_mqlapi_trace_func_Period()
            {
                ENUM_TIMEFRAMES                 retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::Period();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_PositionGetDouble(ENUM_POSITION_PROPERTY_DOUBLE property_id)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionGetDouble(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PositionGetDouble(ENUM_POSITION_PROPERTY_DOUBLE property_id, double& double_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionGetDouble(property_id, double_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, double_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_PositionGetInteger(ENUM_POSITION_PROPERTY_INTEGER property_id)
            {
                switch(property_id)
                {
                    case POSITION_TYPE:             return(dbg_mqlapi_trace_func_PositionGetInteger_ENUM_POSITION_TYPE(property_id));
                    case POSITION_REASON:           return(dbg_mqlapi_trace_func_PositionGetInteger_ENUM_POSITION_REASON(property_id));
                    case POSITION_TIME:
                    case POSITION_TIME_UPDATE:      return(dbg_mqlapi_trace_func_PositionGetInteger_datetime(property_id));
                }
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PositionGetInteger(ENUM_POSITION_PROPERTY_INTEGER property_id, long& long_var)
            {
                switch(property_id)
                {
                    case POSITION_TYPE:             return(dbg_mqlapi_trace_func_PositionGetInteger_ENUM_POSITION_TYPE(property_id, long_var));
                    case POSITION_REASON:           return(dbg_mqlapi_trace_func_PositionGetInteger_ENUM_POSITION_REASON(property_id, long_var));
                    case POSITION_TIME:
                    case POSITION_TIME_UPDATE:      return(dbg_mqlapi_trace_func_PositionGetInteger_datetime(property_id, long_var));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionGetInteger(property_id, long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_PositionGetInteger_ENUM_POSITION_TYPE(ENUM_POSITION_PROPERTY_INTEGER property_id)
            {
                ENUM_POSITION_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_POSITION_TYPE)::PositionGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_PositionGetInteger_ENUM_POSITION_TYPE(ENUM_POSITION_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionGetInteger(property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_POSITION_TYPE long_var = (ENUM_POSITION_TYPE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_PositionGetInteger_ENUM_POSITION_REASON(ENUM_POSITION_PROPERTY_INTEGER property_id)
            {
                ENUM_POSITION_REASON retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_POSITION_REASON)::PositionGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_PositionGetInteger_ENUM_POSITION_REASON(ENUM_POSITION_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionGetInteger(property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_POSITION_REASON long_var = (ENUM_POSITION_REASON)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_PositionGetInteger_datetime(ENUM_POSITION_PROPERTY_INTEGER property_id)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (datetime)::PositionGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_PositionGetInteger_datetime(ENUM_POSITION_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionGetInteger(property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const datetime long_var = (datetime)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_PositionGetString(ENUM_POSITION_PROPERTY_STRING property_id)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionGetString(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PositionGetString(ENUM_POSITION_PROPERTY_STRING property_id, string& string_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionGetString(property_id, string_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_PositionGetSymbol(int index)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, index, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionGetSymbol(index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ulong dbg_mqlapi_trace_func_PositionGetTicket(int index)
            {
                ulong retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, index, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionGetTicket(index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PositionSelect(string symbol)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, symbol, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionSelect(symbol);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PositionSelectByTicket(ulong ticket)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, ticket, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionSelectByTicket(ticket);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_PositionsTotal()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PositionsTotal();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_SocketCreate(uint flags)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, flags, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketCreate(flags);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SocketClose(const int socket)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, socket, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketClose(socket);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SocketConnect(int socket, const string server, uint port, uint timeout_receive_ms)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, socket, server, port, timeout_receive_ms, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketConnect(socket, server, port, timeout_receive_ms);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SocketIsConnected(const int socket)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, socket, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketIsConnected(socket);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            uint dbg_mqlapi_trace_func_SocketIsReadable(const int socket)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, socket, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketIsReadable(socket);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SocketIsWritable(const int socket)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, socket, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketIsWritable(socket);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SocketTimeouts(int socket, uint timeout_send_ms, uint timeout_receive_ms)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, socket, timeout_send_ms, timeout_receive_ms, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketTimeouts(socket, timeout_send_ms, timeout_receive_ms);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_SocketRead(int socket, uchar& buffer[], uint buffer_maxlen, uint timeout_ms)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, socket, buffer_maxlen, timeout_ms, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketRead(socket, buffer, buffer_maxlen, timeout_ms);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, buffer, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_SocketSend(int socket, const uchar& buffer[], uint buffer_len)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, socket, buffer, buffer_len, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketSend(socket, buffer, buffer_len);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SocketTlsHandshake(int socket, const string host)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, socket, host, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketTlsHandshake(socket, host);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_SocketTlsCertificate(int socket, string& subject, string& issuer, string& serial, string& thumbprint, datetime& expiration)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, socket, subject, issuer, serial, thumbprint, expiration, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketTlsCertificate(socket, subject, issuer, serial, thumbprint, expiration);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_SocketTlsRead(int socket, uchar& buffer[], uint buffer_maxlen)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, socket, buffer_maxlen, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketTlsRead(socket, buffer, buffer_maxlen);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, buffer, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_SocketTlsReadAvailable(int socket, uchar& buffer[], const uint buffer_maxlen)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, socket, buffer_maxlen, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketTlsReadAvailable(socket, buffer, buffer_maxlen);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, buffer, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_SocketTlsSend(int socket, const uchar& buffer[], uint buffer_len)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, socket, buffer, buffer_len, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SocketTlsSend(socket, buffer, buffer_len);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_StringReserve(string& string_var, uint new_capacity)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, string_var, new_capacity, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringReserve(string_var, new_capacity);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_StringSetLength(string& string_var, uint new_length)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, string_var, new_length, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringSetLength(string_var, new_length);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_StringTrimRight(string& string_var)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringTrimRight(string_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T>
            bool dbg_mqlapi_trace_func_StructToCharArray(const T& struct_object, uchar& char_array[], uint start_pos = 0)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, struct_object, start_pos, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StructToCharArray(struct_object, char_array, start_pos);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, struct_object, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SymbolExist(string name, bool& is_custom)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolExist(name, is_custom);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, is_custom, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SymbolInfoMarginRate(string name, ENUM_ORDER_TYPE order_type, double& initial_margin_rate, double& maintenance_margin_rate)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, name, order_type, initial_margin_rate, maintenance_margin_rate, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoMarginRate(name, order_type, initial_margin_rate, maintenance_margin_rate);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, initial_margin_rate, maintenance_margin_rate, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_TesterDeposit(double money)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, money, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TesterWithdrawal(money);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_TesterWithdrawal(double money)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, money, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TesterDeposit(money);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_TimeTradeServer()
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TimeTradeServer();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_TimeTradeServer(MqlDateTime& dt_struct)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TimeTradeServer(dt_struct);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dt_struct, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };


        // MQL-API variable input function rewrite

            template <typename A01>
            int dbg_mqlapi_trace_func_CopySeries(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, ulong rates_mask, A01& array1[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool COPY_RATES_OPEN          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OPEN) != NULL);
                const bool COPY_RATES_HIGH          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_HIGH) != NULL);
                const bool COPY_RATES_LOW           = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_LOW) != NULL);
                const bool COPY_RATES_CLOSE         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_CLOSE) != NULL);
                const bool COPY_RATES_TIME          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_TIME) != NULL);
                const bool COPY_RATES_VOLUME_TICK   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_TICK) != NULL);
                const bool COPY_RATES_VOLUME_REAL   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_REAL) != NULL);
                const bool COPY_RATES_SPREAD        = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_SPREAD) != NULL);
                const bool COPY_RATES_OHLC          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLC) != NULL);
                const bool COPY_RATES_OHLCT         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLCT) != NULL);
                const bool COPY_RATES_VERTICAL      = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VERTICAL) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, COPY_RATES_OHLCT, COPY_RATES_VERTICAL, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, COPY_RATES_LOW, COPY_RATES_CLOSE, COPY_RATES_TIME, COPY_RATES_VOLUME_TICK, COPY_RATES_VOLUME_REAL, COPY_RATES_SPREAD, COPY_RATES_OHLC);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol_name, timeframe, start_pos, count, rates_mask, COPY_RATES_OPEN, COPY_RATES_HIGH);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopySeries(symbol_name, timeframe, start_pos, count, rates_mask, array1);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array1, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename A01, typename A02>
            int dbg_mqlapi_trace_func_CopySeries(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, ulong rates_mask, A01& array1[], A02& array2[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool COPY_RATES_OPEN          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OPEN) != NULL);
                const bool COPY_RATES_HIGH          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_HIGH) != NULL);
                const bool COPY_RATES_LOW           = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_LOW) != NULL);
                const bool COPY_RATES_CLOSE         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_CLOSE) != NULL);
                const bool COPY_RATES_TIME          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_TIME) != NULL);
                const bool COPY_RATES_VOLUME_TICK   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_TICK) != NULL);
                const bool COPY_RATES_VOLUME_REAL   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_REAL) != NULL);
                const bool COPY_RATES_SPREAD        = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_SPREAD) != NULL);
                const bool COPY_RATES_OHLC          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLC) != NULL);
                const bool COPY_RATES_OHLCT         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLCT) != NULL);
                const bool COPY_RATES_VERTICAL      = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VERTICAL) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, COPY_RATES_OHLCT, COPY_RATES_VERTICAL, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, COPY_RATES_LOW, COPY_RATES_CLOSE, COPY_RATES_TIME, COPY_RATES_VOLUME_TICK, COPY_RATES_VOLUME_REAL, COPY_RATES_SPREAD, COPY_RATES_OHLC);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol_name, timeframe, start_pos, count, rates_mask, COPY_RATES_OPEN, COPY_RATES_HIGH);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopySeries(symbol_name, timeframe, start_pos, count, rates_mask, array1, array2);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, array1, array2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename A01, typename A02, typename A03>
            int dbg_mqlapi_trace_func_CopySeries(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, ulong rates_mask, A01& array1[], A02& array2[], A03& array3[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool COPY_RATES_OPEN          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OPEN) != NULL);
                const bool COPY_RATES_HIGH          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_HIGH) != NULL);
                const bool COPY_RATES_LOW           = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_LOW) != NULL);
                const bool COPY_RATES_CLOSE         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_CLOSE) != NULL);
                const bool COPY_RATES_TIME          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_TIME) != NULL);
                const bool COPY_RATES_VOLUME_TICK   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_TICK) != NULL);
                const bool COPY_RATES_VOLUME_REAL   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_REAL) != NULL);
                const bool COPY_RATES_SPREAD        = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_SPREAD) != NULL);
                const bool COPY_RATES_OHLC          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLC) != NULL);
                const bool COPY_RATES_OHLCT         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLCT) != NULL);
                const bool COPY_RATES_VERTICAL      = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VERTICAL) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, COPY_RATES_OHLCT, COPY_RATES_VERTICAL, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, COPY_RATES_LOW, COPY_RATES_CLOSE, COPY_RATES_TIME, COPY_RATES_VOLUME_TICK, COPY_RATES_VOLUME_REAL, COPY_RATES_SPREAD, COPY_RATES_OHLC);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol_name, timeframe, start_pos, count, rates_mask, COPY_RATES_OPEN, COPY_RATES_HIGH);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopySeries(symbol_name, timeframe, start_pos, count, rates_mask, array1, array2, array3);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(3, array1, array2, array3, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename A01, typename A02, typename A03, typename A04>
            int dbg_mqlapi_trace_func_CopySeries(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, ulong rates_mask, A01& array1[], A02& array2[], A03& array3[], A04& array4[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool COPY_RATES_OPEN          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OPEN) != NULL);
                const bool COPY_RATES_HIGH          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_HIGH) != NULL);
                const bool COPY_RATES_LOW           = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_LOW) != NULL);
                const bool COPY_RATES_CLOSE         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_CLOSE) != NULL);
                const bool COPY_RATES_TIME          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_TIME) != NULL);
                const bool COPY_RATES_VOLUME_TICK   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_TICK) != NULL);
                const bool COPY_RATES_VOLUME_REAL   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_REAL) != NULL);
                const bool COPY_RATES_SPREAD        = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_SPREAD) != NULL);
                const bool COPY_RATES_OHLC          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLC) != NULL);
                const bool COPY_RATES_OHLCT         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLCT) != NULL);
                const bool COPY_RATES_VERTICAL      = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VERTICAL) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, COPY_RATES_OHLCT, COPY_RATES_VERTICAL, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, COPY_RATES_LOW, COPY_RATES_CLOSE, COPY_RATES_TIME, COPY_RATES_VOLUME_TICK, COPY_RATES_VOLUME_REAL, COPY_RATES_SPREAD, COPY_RATES_OHLC);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol_name, timeframe, start_pos, count, rates_mask, COPY_RATES_OPEN, COPY_RATES_HIGH);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopySeries(symbol_name, timeframe, start_pos, count, rates_mask, array1, array2, array3, array4);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(4, array1, array2, array3, array4, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename A01, typename A02, typename A03, typename A04, typename A05>
            int dbg_mqlapi_trace_func_CopySeries(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, ulong rates_mask, A01& array1[], A02& array2[], A03& array3[], A04& array4[], A05& array5[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool COPY_RATES_OPEN          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OPEN) != NULL);
                const bool COPY_RATES_HIGH          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_HIGH) != NULL);
                const bool COPY_RATES_LOW           = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_LOW) != NULL);
                const bool COPY_RATES_CLOSE         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_CLOSE) != NULL);
                const bool COPY_RATES_TIME          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_TIME) != NULL);
                const bool COPY_RATES_VOLUME_TICK   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_TICK) != NULL);
                const bool COPY_RATES_VOLUME_REAL   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_REAL) != NULL);
                const bool COPY_RATES_SPREAD        = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_SPREAD) != NULL);
                const bool COPY_RATES_OHLC          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLC) != NULL);
                const bool COPY_RATES_OHLCT         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLCT) != NULL);
                const bool COPY_RATES_VERTICAL      = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VERTICAL) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, COPY_RATES_OHLCT, COPY_RATES_VERTICAL, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, COPY_RATES_LOW, COPY_RATES_CLOSE, COPY_RATES_TIME, COPY_RATES_VOLUME_TICK, COPY_RATES_VOLUME_REAL, COPY_RATES_SPREAD, COPY_RATES_OHLC);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol_name, timeframe, start_pos, count, rates_mask, COPY_RATES_OPEN, COPY_RATES_HIGH);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopySeries(symbol_name, timeframe, start_pos, count, rates_mask, array1, array2, array3, array4, array5);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(5, array1, array2, array3, array4, array5, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename A01, typename A02, typename A03, typename A04, typename A05, typename A06>
            int dbg_mqlapi_trace_func_CopySeries(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, ulong rates_mask, A01& array1[], A02& array2[], A03& array3[], A04& array4[], A05& array5[], A06& array6[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool COPY_RATES_OPEN          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OPEN) != NULL);
                const bool COPY_RATES_HIGH          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_HIGH) != NULL);
                const bool COPY_RATES_LOW           = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_LOW) != NULL);
                const bool COPY_RATES_CLOSE         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_CLOSE) != NULL);
                const bool COPY_RATES_TIME          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_TIME) != NULL);
                const bool COPY_RATES_VOLUME_TICK   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_TICK) != NULL);
                const bool COPY_RATES_VOLUME_REAL   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_REAL) != NULL);
                const bool COPY_RATES_SPREAD        = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_SPREAD) != NULL);
                const bool COPY_RATES_OHLC          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLC) != NULL);
                const bool COPY_RATES_OHLCT         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLCT) != NULL);
                const bool COPY_RATES_VERTICAL      = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VERTICAL) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, COPY_RATES_OHLCT, COPY_RATES_VERTICAL, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, COPY_RATES_LOW, COPY_RATES_CLOSE, COPY_RATES_TIME, COPY_RATES_VOLUME_TICK, COPY_RATES_VOLUME_REAL, COPY_RATES_SPREAD, COPY_RATES_OHLC);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol_name, timeframe, start_pos, count, rates_mask, COPY_RATES_OPEN, COPY_RATES_HIGH);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopySeries(symbol_name, timeframe, start_pos, count, rates_mask, array1, array2, array3, array4, array5, array6);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(6, array1, array2, array3, array4, array5, array6, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename A01, typename A02, typename A03, typename A04, typename A05, typename A06, typename A07>
            int dbg_mqlapi_trace_func_CopySeries(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, ulong rates_mask, A01& array1[], A02& array2[], A03& array3[], A04& array4[], A05& array5[], A06& array6[], A07& array7[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool COPY_RATES_OPEN          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OPEN) != NULL);
                const bool COPY_RATES_HIGH          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_HIGH) != NULL);
                const bool COPY_RATES_LOW           = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_LOW) != NULL);
                const bool COPY_RATES_CLOSE         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_CLOSE) != NULL);
                const bool COPY_RATES_TIME          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_TIME) != NULL);
                const bool COPY_RATES_VOLUME_TICK   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_TICK) != NULL);
                const bool COPY_RATES_VOLUME_REAL   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_REAL) != NULL);
                const bool COPY_RATES_SPREAD        = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_SPREAD) != NULL);
                const bool COPY_RATES_OHLC          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLC) != NULL);
                const bool COPY_RATES_OHLCT         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLCT) != NULL);
                const bool COPY_RATES_VERTICAL      = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VERTICAL) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, COPY_RATES_OHLCT, COPY_RATES_VERTICAL, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, COPY_RATES_LOW, COPY_RATES_CLOSE, COPY_RATES_TIME, COPY_RATES_VOLUME_TICK, COPY_RATES_VOLUME_REAL, COPY_RATES_SPREAD, COPY_RATES_OHLC);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol_name, timeframe, start_pos, count, rates_mask, COPY_RATES_OPEN, COPY_RATES_HIGH);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopySeries(symbol_name, timeframe, start_pos, count, rates_mask, array1, array2, array3, array4, array5, array6, array7);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(7, array1, array2, array3, array4, array5, array6, array7);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename A01, typename A02, typename A03, typename A04, typename A05, typename A06, typename A07, typename A08>
            int dbg_mqlapi_trace_func_CopySeries(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, ulong rates_mask, A01& array1[], A02& array2[], A03& array3[], A04& array4[], A05& array5[], A06& array6[], A07& array7[], A08& array8[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool COPY_RATES_OPEN          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OPEN) != NULL);
                const bool COPY_RATES_HIGH          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_HIGH) != NULL);
                const bool COPY_RATES_LOW           = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_LOW) != NULL);
                const bool COPY_RATES_CLOSE         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_CLOSE) != NULL);
                const bool COPY_RATES_TIME          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_TIME) != NULL);
                const bool COPY_RATES_VOLUME_TICK   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_TICK) != NULL);
                const bool COPY_RATES_VOLUME_REAL   = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VOLUME_REAL) != NULL);
                const bool COPY_RATES_SPREAD        = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_SPREAD) != NULL);
                const bool COPY_RATES_OHLC          = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLC) != NULL);
                const bool COPY_RATES_OHLCT         = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_OHLCT) != NULL);
                const bool COPY_RATES_VERTICAL      = ((rates_mask & ENUM_COPY_RATES::COPY_RATES_VERTICAL) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, COPY_RATES_OHLCT, COPY_RATES_VERTICAL, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, COPY_RATES_LOW, COPY_RATES_CLOSE, COPY_RATES_TIME, COPY_RATES_VOLUME_TICK, COPY_RATES_VOLUME_REAL, COPY_RATES_SPREAD, COPY_RATES_OHLC);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, symbol_name, timeframe, start_pos, count, rates_mask, COPY_RATES_OPEN, COPY_RATES_HIGH);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopySeries(symbol_name, timeframe, start_pos, count, rates_mask, array1, array2, array3, array4, array5, array6, array7, array8);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array8, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(7, array1, array2, array3, array4, array5, array6, array7);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };


        // MQL-API void-typed function rewrite

            template <typename T> void dbg_mqlapi_trace_func_ArrayPrint(const T& arr[], uint digits = UINT_MAX, const string separator = NULL, ulong start = 0, ulong count = WHOLE_ARRAY, ulong flags = ARRAYPRINT_HEADER | ARRAYPRINT_INDEX | ARRAYPRINT_LIMIT | ARRAYPRINT_ALIGN)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                uint _digits = (digits == UINT_MAX) ? _Digits : digits;
                const bool ARRAYPRINT_HEADER        = ((flags & ARRAYPRINT_HEADER) != NULL);
                const bool ARRAYPRINT_INDEX         = ((flags & ARRAYPRINT_INDEX) != NULL);
                const bool ARRAYPRINT_LIMIT         = ((flags & ARRAYPRINT_LIMIT) != NULL);
                const bool ARRAYPRINT_ALIGN         = ((flags & ARRAYPRINT_ALIGN) != NULL);
                const bool ARRAYPRINT_DATE          = ((flags & ARRAYPRINT_DATE) != NULL);
                const bool ARRAYPRINT_MINUTES       = ((flags & ARRAYPRINT_MINUTES) != NULL);
                const bool ARRAYPRINT_SECONDS       = ((flags & ARRAYPRINT_SECONDS) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, ARRAYPRINT_INDEX, ARRAYPRINT_LIMIT, ARRAYPRINT_ALIGN, ARRAYPRINT_DATE, ARRAYPRINT_MINUTES, ARRAYPRINT_SECONDS, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, arr, _digits, separator, start, count, flags, ARRAYPRINT_HEADER);
                ArrayPrint(arr, _digits, separator, start, count, flags);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_CLBufferFree(const int buffer)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, buffer, 0, 0, 0, 0, 0, 0);
                CLBufferFree(buffer);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_CLContextFree(const int context)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, context, 0, 0, 0, 0, 0, 0);
                CLContextFree(context);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_CLKernelFree(const int kernel)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, kernel, 0, 0, 0, 0, 0, 0);
                CLKernelFree(kernel);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_CLProgramFree(const int program)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, program, 0, 0, 0, 0, 0, 0);
                CLProgramFree(program);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_DatabaseClose(const int database)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, database, 0, 0, 0, 0, 0, 0);
                DatabaseClose(database);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_DatabaseFinalize(const int request)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, request, 0, 0, 0, 0, 0, 0);
                DatabaseFinalize(request);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_SetReturnError(int ret_code)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, ret_code, 0, 0, 0, 0, 0, 0);
                SetReturnError(ret_code);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_TesterHideIndicators(bool hide)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, hide, 0, 0, 0, 0, 0, 0);
                TesterHideIndicators(hide);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_TesterStop()
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                TesterStop();
                return;
            };
    };


#ifndef __MQL4__
    };

#endif

//
/////////////////////////////////////////////////////////////////////////////////////////////////////



//
// END Debugging support
//*********************************************************************************************************************************************************/
#endif // LIB_DBG_DEBUG_MQLAPI_MQL5_TRACER_MQH_INCLUDED
